;BATVALSD.ASM     Battle Valley sound driver     J.Dave Rogers, March 1988

;***********
SPECVERSION  EQU   0       ;0=AMSTRAD 1=SPEC

SOUNDCOD     EQU   32768      ;MACHINE CODE

SOUNDATA     EQU   SOUNDCOD + 1104  ;DATABLOCK ADDRESS
;**********

             NOLIST

ENVSINDEX    EQU       SOUNDATA+200
TUNESINDEX   EQU       ENVSINDEX+80

ENVCOUNTS    EQU 0
ENTCOUNTS    EQU 2
ENVPTR       EQU 4
ENTPTR       EQU 6
ENV0         EQU 8
ENT0         EQU 10
ENVADR       EQU 12
ENTADR       EQU 14

CHANACTIVE   EQU 16
MAINCOUNT    EQU 17
DATAPTR      EQU 18
CONPTR       EQU 20
PTRREFR      EQU 22
PITCHSHIFT   EQU 24
NOISEDIS     EQU 25
CH_ENABLE    EQU 26
INTERVAL     EQU 27
CURRENTNOTE  EQU 28
CHORDTOGGLE  EQU 29

             ORG  SOUNDCOD
             WRITE "BATVALSD.BIN"
START        DEFL $

;---------------------------------------
JUMPBLOCK:      JP PLAY
                JP SILENCE
                JP TUNE48K
SPEC48FLAG      DB 0
STARTUNE:       LD E,1
                LD A,1
;--------
STARTACHAN:     LD C,A
                CALL FINDBLOC
                LD A,(HL)
                CP 9
                JR NC,NOCHANMARKER
                LD C,A
                INC HL
NOCHANMARKER:   LD A,(HL)
                CP 244
                LD B,10
                JR NZ,FINDCHAN
                INC HL
                LD B,(HL)
                INC HL
FINDCHAN:       DEC C
                JR Z,TRY1
                DEC C
                JR Z,TRY2
                DEC C
                JR Z,TRY3

CHANALT:        LD A,(STORE2+CHANACTIVE)
                OR A
                JR Z,TRY2
                LD A,(STORE1+CHANACTIVE)
                OR A
                JR Z,TRY1

TRY3:           LD DE,STORE3+CHANACTIVE
                LD A,(DE)
                LD C,A
                LD A,B
                SUB C
                RET C
                XOR A
                LD (DE),A
                LD (STORE3+INTERVAL),A
                LD (STORE3+PITCHSHIFT),A
                INC A
                LD (STORE3+MAINCOUNT),A
                LD (STORE3+DATAPTR),HL
                LD (STORE3+CONPTR),HL
                LD (STORE3+PTRREFR),HL
                LD A,B
                LD (DE),A
                RET

TRY2:           LD DE,STORE2+CHANACTIVE
                LD A,(DE)
                LD C,A
                LD A,B
                SUB C
                RET C
                XOR A
                LD (DE),A
                LD (STORE2+INTERVAL),A
                LD (STORE2+PITCHSHIFT),A
                INC A
                LD (STORE2+MAINCOUNT),A
                LD (STORE2+DATAPTR),HL
                LD (STORE2+CONPTR),HL
                LD (STORE2+PTRREFR),HL
                LD A,B
                LD (DE),A
                RET

TRY1:           LD DE,STORE1+CHANACTIVE
                LD A,(DE)
                LD C,A
                LD A,B
                SUB C
                RET C
                XOR A
                LD (DE),A
                LD (STORE1+INTERVAL),A
                LD (STORE1+PITCHSHIFT),A
                INC A
                LD (STORE1+MAINCOUNT),A
                LD (STORE1+DATAPTR),HL
                LD (STORE1+CONPTR),HL
                LD (STORE1+PTRREFR),HL
                LD A,B
                LD (DE),A
                RET

;------
SILENCE:        LD A,1+2+4+8+16+32
                LD (BUFF+7),A
                XOR A
                LD (SPEC48FLAG),A
                LD  (STORE1+CHANACTIVE),A
                LD  (STORE2+CHANACTIVE),A
                LD  (STORE3+CHANACTIVE),A
                LD (STORE1+INTERVAL),A
                LD (STORE2+INTERVAL),A
                LD (STORE3+INTERVAL),A
                LD (STORE1+PITCHSHIFT),A
                LD (STORE2+PITCHSHIFT),A
                LD (STORE3+PITCHSHIFT),A
                LD (BUFF+8),A
                LD (BUFF+9),A
                LD (BUFF+10),A

;********
IF SPECVERSION

ALL13REGS:      LD HL,BUFF+13
                LD E,13
                JP NEXTREG
ELSE

ALL13REGS:      LD HL,BUFF+13    ;A STILL = 0
                LD DE,#F40D      ;13
                JP NEXTREG
ENDIF
;********

FINDBLOC:       LD   A,E
                ADD  A,A
                ADD  A,TUNESINDEX AND #00FF
                LD   L,A
                ADC  A,TUNESINDEX AND #FF00 /256
                SUB  L
                LD   H,A
                LD   E,(HL)
                INC  HL
                LD   D,(HL)
                LD HL,SOUNDATA
                ADD HL,DE
                RET

FINDENV:        LD   A,E
                ADD  A,A
                ADD  A,ENVSINDEX AND #00FF
                LD   E,A
                ADC  A,ENVSINDEX AND #FF00 / 256
                SUB  E
                LD   D,A

                LD  A,(DE)
                ADD A,SOUNDATA AND #00FF
                LD  C,A

                INC  DE
                LD  A,(DE)
                ADC A,SOUNDATA AND #FF00 / 256
                LD B,A
                RET

;---------EVERY 1/25 S-------------

PLAY:           LD HL,STOPHANG
                LD (HL),20

                LD A,(STORE1+CHANACTIVE)
                OR A
                JR Z,C2
                LD  IX,STORE1
                LD IY,BUFF+8
                LD HL,(BUFF)
                LD (PITCHTEMP),HL
                LD HL,(STORE1+DATAPTR)
                CALL TESTCHAN
                LD (BUFF),HL

C2:             LD A,(STORE2+CHANACTIVE)
                OR A
                JR Z,C3
                LD  IX,STORE2
                LD IY,BUFF+9
                LD HL,(BUFF+2)
                LD (PITCHTEMP),HL
                LD HL,(STORE2+DATAPTR)
                CALL TESTCHAN
                LD (BUFF+2),HL

C3:             LD A,(STORE3+CHANACTIVE)
                OR A
                JR Z,CHORUS

                LD IX,STORE3
                LD IY,BUFF+10
                LD HL,(BUFF+4)
                LD (PITCHTEMP),HL
                LD HL,(STORE3+DATAPTR)
                CALL TESTCHAN
                JP NOCHORUS

CHORUS:         OR H    ;A ALWAYS 0 HERE
                OR L
                JR Z,NOCHORUS     ;PAUSES
                DEC L
                DEC L
                LD A,(BUFF+9)
                LD (BUFF+10),A
NOCHORUS:       LD (BUFF+4),HL

                CALL DOENSE

;*************
IF SPECVERSION

                LD A,(SPEC48FLAG)
                OR A
                RET NZ     ;NO AY CHIP IF 48K TUNE

ALLREGIST:      LD HL,BUFF+10
                LD E,10
NEXTREG:        LD BC,65533
                OUT (C),E
                LD BC,49149
                LD A,(HL)
                DEC HL
                OUT (C),A
                DEC E
                JP P,NEXTREG
                RET

ELSE

ALLREGIST:      XOR  A
                LD   HL,BUFF+10 ;10
                LD   DE,#F40A   ;10
NEXTREG:        LD   B,D
                OUT  (C),E
                LD   BC,63168   ;(#F6*256+%11000000)
                OUT  (C),C
                OUT  (C),A
                LD   B,D
                LD   C,(HL)
                DEC  HL
                OUT  (C),C
                LD   BC,63104   ;(#F6*256+%10000000)
                OUT  (C),C
                OUT  (C),A
                DEC  E
                JP   P,NEXTREG
                RET

ENDIF
;**********

;FOR EACH OF THE 3 CHANNELS:

TESTCHAN:       DEC  (IX+MAINCOUNT)
                JP NZ,DOENV_ENT

DECI:           LD   A,(HL)
                INC  HL
                LD   E,(HL)
                INC HL

SUBSELECT:   OR   A
             JP   Z,DOPAUSE
             CP   9
             JP   C,STARTLOOP
             CP   101
             JP   C,NEWNOTE

           SUB 230
           JR  Z,NOISE
           DEC A
           JR  Z,NOISENOCHECK
           DEC A
           JR  Z,QUICKOUT
           DEC A
           JR  Z,NEWENV
           DEC A
           JR  Z,NEWENT
           DEC A
           JR  Z,NEWENSE
           DEC A
           JP  Z,SETINTERVAL
           DEC A
           JR  Z,NEWKEY
           DEC A
           JR  Z,GONEWBLOC
           DEC A
           JR  Z,RETCONBLOC

          ;FOLLOW THROUGH=SAFETY NET

KILLCHAN:       LD (IX+CHANACTIVE),0
                LD (IY+0),0
                RET

QUICKOUT:       LD (IX+MAINCOUNT),1     ;TIME SHARER
                DEC HL
                LD (IX+DATAPTR),L
                LD (IX+DATAPTR+1),H
                LD HL,0
                RET

STARTLOOP:      PUSH IX     ;A=CHAN E=TUNEBLOC
                PUSH HL
                CALL STARTACHAN
                POP HL
                POP IX

                LD A,(STOPHANG)  ;JUST IN CASE!
                DEC A
                RET Z
                LD (STOPHANG),A
                JP DECI

NOISE:          LD A,(STORE3+CHANACTIVE)   ;NO TUNE-DRUMS IF CH3 ACTIVE
                OR A
                JR NZ, DECI
NOISENOCHECK:   LD   A,E
                LD   (BUFF+6),A
                LD A,1
                LD   (NSEFLAG),A
                JP   DECI

NEWKEY:         LD   (IX+PITCHSHIFT),E
                JP   DECI

NEWENT:         CALL FINDENV
                LD (IX+ENTADR),C
                LD (IX+ENTADR+1),B
                JP DECI

NEWENV:         CALL FINDENV
                LD (IX+ENVADR),C
                LD (IX+ENVADR+1),B
                JP DECI

NEWENSE:        CALL FINDENV
                LD (ENSSTORE+12),BC
                JP DECI

GONEWBLOC:      LD   (IX+CONPTR+1),H
                LD   (IX+CONPTR),L
                CALL FINDBLOC
                JP   DECI

RETCONBLOC:     LD   H,(IX+CONPTR+1)
                LD   L,(IX+CONPTR)
                LD A,(HL)
                INC A
                JP NZ,DECI
                LD H,(IX+PTRREFR+1)
                LD L,(IX+PTRREFR)
                JP DECI

SETINTERVAL:    LD (IX+INTERVAL),E
                JP DECI

NEWNOTE:        ADD  A,(IX+PITCHSHIFT)

;******
IF SPECVERSION
                LD C,A
                LD A,(SPEC48FLAG)
                OR A
                JP NZ, NOSUB
                LD A,C
                SUB 12       ;HALVE FREQY IF SPECTRUM (AY CLOCKED AT 2 MHZ)
                LD C,A
NOSUB           LD A,C       ;BUT NOT IF 48 K !
ENDIF
;******

DOPAUSE:        LD   (IX+MAINCOUNT),E
                LD   (IX+CURRENTNOTE),A
                LD   (IX+DATAPTR+1),H
                LD   (IX+DATAPTR),L

PITCHTAB        EQU  SOUNDATA

                ADD  A,A
                ADD  A,PITCHTAB AND #00FF
                LD   L,A
                ADC  A,PITCHTAB AND #FF00 /256
                SUB  L
                LD   H,A
                LD   DE,PITCHTEMP
                LDI
                LDI

                LD (IY+0),0

                PUSH IX     ;RESTART ENV/ent
                POP  DE
                LD   HL,8
                ADD  HL,DE
                LDI
                LDI
                LDI
                LDI
                LDI
                LDI
                LDI
                LDI

                XOR A
                LD HL,NSEFLAG
                OR   (HL)
                LD   (HL),0
                LD   L,(IX+NOISEDIS)
                JR   Z,GATING

NOISEON:        LD  HL,(ENSSTORE+ENVADR)
                LD  (ENSSTORE+ENVPTR),HL
                LD  HL,00
                LD  (ENSSTORE),HL

GATING:         LD   A,(BUFF+7)
                AND  (IX+CH_ENABLE)
                OR   L
                AND  32+16+8+4+2+1
                LD   (BUFF+7),A
;-------

DOENV_ENT:      PUSH IX
                POP  HL
                LD   D,(IX+ENVPTR+1)
                LD   E,(IX+ENVPTR)
                INC  (HL)
                LD   A,(DE)
                SUB  (HL)
                JP  NZ,NOENV
                LD   (HL),A
                INC DE
                LD  A,(DE)

                ADD (IY+0)
                SUB  128
                LD   (IY+0),A

                INC  DE
                INC  HL
                INC  (HL)
                LD   A,(DE)
                SUB  (HL)
                JP  NZ,NOENV
                LD   (HL),A
                INC  DE
                LD   A,(DE)
                INC  A
                JP   NZ,NEXTSECT
                LD   D,(IX+ENVADR+1)
                LD   E,(IX+ENVADR)
NEXTSECT:       LD   (IX+ENVPTR+1),D
                LD   (IX+ENVPTR),E

;----
NOENV:          LD HL,(PITCHTEMP)   ;PAUSE ?
                LD A,H
                OR L
                RET Z
                LD A,(IX+INTERVAL)  ;CHORD ?
                OR A
                JR NZ,DOCHORD
DOENT:          PUSH IX
                POP  HL
                INC HL
                INC HL
                LD   D,(IX+ENTPTR+1)
                LD   E,(IX+ENTPTR)
                INC  (HL)
                LD   A,(DE)
                SUB  (HL)
                JP  NZ,NOPITCH
                LD   (HL),A
                INC DE
                LD  A,(DE)
                LD  C,A
                INC  DE
                INC  HL
                INC  (HL)
                LD   A,(DE)
                SUB  (HL)
                JP  NZ,DOPITCH
                LD   (HL),A
                INC  DE
                LD   A,(DE)
                INC  A
                JP   NZ,NEXTSECT2
                LD   D,(IX+ENTADR+1)
                LD   E,(IX+ENTADR)
NEXTSECT2:      LD   (IX+ENTPTR+1),D
                LD   (IX+ENTPTR),E

DOPITCH:        LD HL,(PITCHTEMP)
                LD B,0
;*******
IF SPECVERSION
                ADD  HL,BC
                ADD HL,BC
                LD   C,128
                SBC HL,BC
                SBC  HL,BC
ELSE
                ADD HL,BC
                LD C,128
                SBC HL,BC
ENDIF
;*******

GETOUT:         RET

NOPITCH:        LD HL,(PITCHTEMP)
                RET

DOCHORD:        DEC (IX+CHORDTOGGLE)
                LD A,(IX+CURRENTNOTE)
                JR Z,FINDSETPITCH
                ADD (IX+INTERVAL)
                LD (IX+CHORDTOGGLE),1

PITCHTAB        EQU  SOUNDATA

FINDSETPITCH:   ADD  A,A
                ADD  A,PITCHTAB AND #00FF
                LD   L,A
                ADC  A,PITCHTAB AND #FF00 /256
                SUB  L
                LD   H,A

                LD   E,(HL)
                INC HL
                LD  D,(HL)
                EX HL,DE
                RET
;------
DOENSE:         LD DE,(ENSSTORE+4)
                LD HL,ENSSTORE
                INC  (HL)
                LD   A,(DE)
                SUB  (HL)
                RET  NZ
                LD   (HL),A
                INC DE
                LD  A,(DE)
                LD  C,A
                INC  DE
                INC  HL
                INC  (HL)
                LD   A,(DE)
                SUB  (HL)
                JP  NZ,DONSE
                LD   (HL),A
                INC  DE
                LD   A,(DE)
                INC  A
                JP   NZ,NEXTSECT3
                LD   DE,(ENSSTORE+12)
NEXTSECT3:      LD   (ENSSTORE+4),DE

DONSE:          LD HL, BUFF+6
                LD   A,(HL)
                ADD  A,C
                SUB  128
                LD   (HL),A
                CP 17
                RET C
NOISEOFF:       INC HL    ;HL=BUFF+7
                LD A,(HL)
                OR 32+16+8
                LD (HL),A
                RET

;---------------------

BUFF:     DW  00
          DW  00
          DW  00
          DB  0
          DB  32+16+8
          DB  0
          DB  0
          DB  0
          DB  1,1
          DB  12

PITCHTEMP:  DW 00

NSEFLAG:    DB 0

STOPHANG:   DB 0

ENSSTORE: DW 00
          DW 10
          DW 00
          DW 04
          DW 00
          DW 18
          DW 00

;CHANNEL STORES

STORE1:   DW  00
          DW  00
          DW  00
          DW  00

          DW  00
          DW  00
          DW  00
          DW  00

          DB  0
          DB  0
          DW  00
          DW  00
          DW  00
          DB  0
          DB   8          ;NOISE DIS
          DB  32+16+4+2-4 ;CHAN ENABLE  (-4 'COS CHORUS=CH3 ALWAYS ON)
          DB  0
          DB  0
          DB  0

STORE2: DW  00
        DW  00
        DW  00
        DW  00

        DW  00
        DW  00
        DW  00
        DW  00

        DB  0
        DB  0
        DW  00
        DW 00
        DW  00
        DB  0
        DB  16
        DB  32+8+4+1-4
        DB  0
        DB  0
        DB  0

STORE3: DW  00
        DW  00
        DW  00
        DW  00

        DW  00
        DW  00
        DW  00
        DW  00

        DB  0
        DB  0
        DW  00
        DW 00
        DW  00
        DB  0
        DB  32
        DB  16+8+2+1
        DB  0
        DB  0
        DB  0
;---------------------48K SOUND----------------

TUNE48K:

;*************
IF SPECVERSION
                CALL SILENCE
                CALL STARTUNE
                LD A,1
                LD (SPEC48FLAG),A
                LD BC, 320*4
FFWD:           PUSH BC
                CALL PLAY
                POP BC
                DEC BC
                LD A,B
                OR C
                JP NZ,FFWD

PLAY48:         XOR A        ;NOW STAYS IN THIS LOOP
                IN A,(254)
                CPL
                AND 31
                RET NZ       ;OUT IF ANY KEY
                CALL PLAY    ;SWTS PITCHES AS IF 128K TUNE
                LD DE,4000   ;TEMPO OF 48K TUNE

                LD HL,(BUFF)  ;main tunes note
                LD A,H
                OR L
                JP NZ,SETPER
                LD HL,(BUFF+2)  ;chan2 note if main chan is pause

SETPER:         DEC HL         ;PAUSE (0) TO 65535 = V.LONG PERIOD BEEP!
                LD (PERIOD),HL

PART1:          LD A,0-0     ;SELF MOD 0 <> 16
                XOR 16
                LD (PART1+1),A
                OUT (&FE),A    ;TOGGLE BEEPER (BIT 4)
                LD HL,(PERIOD)
LOOP1:          DEC E
                JR NZ,CONT
                DEC E
                DEC D
                JR Z,PLAY48
CONT:           DEC L
                JP NZ,LOOP1
                LD A,H
                OR A
                JR Z,PART1
                DEC H
                DEC L
                JP LOOP1

PERIOD          DW 00

ENDIF
;********

SPARE           DB 42

;---------
FINISH          DEFL $
                LIST
                CLOSE
START           DEFL START
FINISH          DEFL FINISH
LENGTH          DEFL FINISH-START
SPECVERSION  EQU   0       ;0=AMSTRA