; BEARGRSD.ASM    BEAR A GRUDGE Sound Driver

;-------VERSION FOR CHRIS WOOD'S COVER GAME---------J.Dave Rogers 88------


SPECVERSION  EQU   0                ;0=AMSTRAD 1=SPEC (CONDITIONAL ASSEMBLY)

SOUNDCOD     EQU   32768            ;MACHINE CODE

SOUNDATA     EQU   SOUNDCOD + 1300   ;DATABLOCK ADDRESS



             NOLIST

ENVSINDEX    EQU       SOUNDATA+200
TUNESINDEX   EQU       ENVSINDEX+80

ENVCOUNTS    EQU 0
ENTCOUNTS    EQU 2
ENVPTR       EQU 4
ENTPTR       EQU 6
ENV0         EQU 8
ENT0         EQU 10
ENVADR       EQU 12
ENTADR       EQU 14

CHANACTIVE   EQU 16
MAINCOUNT    EQU 17
DATAPTR      EQU 18
CONPTR       EQU 20
PTRREFR      EQU 22
PITCHSHIFT   EQU 24
NOISEDIS     EQU 25
CH_ENABLE    EQU 26
INTERVAL     EQU 27
CURRENTNOTE  EQU 28
CHORDTOGGLE  EQU 29
CURRENTDUR   EQU 30

             ORG  SOUNDCOD
             WRITE "BEARGRSD.BIN"
START        DEFL $

;------------------------
JUMPBLOCK       JP PLAY128
                JP SILENCE
                JP play128
SPEC48FLAG      DB 1
BASICSTART      LD E,1
                LD C,1

;----------------------
STARTASOUND     CALL FINDBLOC      ;E=BLOC   HL=BLOCADR
                LD A,(HL)          ;C=CHAN   B=PRIORITY
                CP 9
                JR NC,NOCHANMARKER
                LD C,A
                INC HL
                LD A,(HL)
NOCHANMARKER    DEC C        ;FINDCHAN
                JR Z,TRY1
                DEC C
                JR Z,TRY2
                DEC C
                JR Z,TRY3                ;ch4=alternating;
CHAN4           LD A,(STORE1+CHANACTIVE)   ;chan 1 if poss.else 3
                OR A
                JR Z,TRY1
                JP TRY3

TRY1            LD DE,STORE1+CHANACTIVE
                XOR A
                LD (DE),A
                LD (STORE1+INTERVAL),A
                LD (STORE1+PITCHSHIFT),A
                INC A
                LD (STORE1+MAINCOUNT),A
                LD (STORE1+DATAPTR),HL
                LD (STORE1+CONPTR),HL
                LD (STORE1+PTRREFR),HL
                LD (DE),A
                RET

TRY2            LD DE,STORE2+CHANACTIVE
                XOR A
                LD (DE),A
                LD (STORE2+INTERVAL),A
                LD (STORE2+PITCHSHIFT),A
                INC A
                LD (STORE2+MAINCOUNT),A
                LD (STORE2+DATAPTR),HL
                LD (STORE2+CONPTR),HL
                LD (STORE2+PTRREFR),HL
                LD (DE),A
                RET

TRY3            LD DE,STORE3+CHANACTIVE
                XOR A
                LD (DE),A
                LD (STORE3+INTERVAL),A
                LD (STORE3+PITCHSHIFT),A
                INC A
                LD (STORE3+MAINCOUNT),A
                LD (STORE3+DATAPTR),HL
                LD (STORE3+CONPTR),HL
                LD (STORE3+PTRREFR),HL
                LD (DE),A
                RET

;------
SILENCE         XOR A
                LD (STORE1+CHANACTIVE),A
                LD (STORE2+CHANACTIVE),A
                LD (STORE3+CHANACTIVE),A
                LD (NSEFLAG),A
                LD (BUFF+8),A
                LD (BUFF+9),A
                LD (BUFF+10),A
                LD A, %00111111   ;ALL GATES SHUT
                LD (BUFF+7),A

;***********
IF SPECVERSION

ALL13REGS       LD HL,BUFF+13
                LD E,13
                XOR A
                JP NEXTREG
ELSE

ALL13REGS       LD HL,BUFF+13
                LD DE,#F40D   ;E=13
                XOR A
                JP NEXTREG
ENDIF
;***********

FINDBLOC        LD   A,E
                ADD  A,A
                ADD  A,TUNESINDEX AND #00FF
                LD   L,A
                ADC  A,TUNESINDEX AND #FF00 /256
                SUB  L
                LD   H,A
                LD   E,(HL)
                INC  HL
                LD   D,(HL)
                LD HL,SOUNDATA
                ADD HL,DE
                RET

FINDENV         LD   A,E       ;must not corrupt hl
                ADD  A,A
                ADD  A,ENVSINDEX AND #00FF
                LD   E,A
                ADC  A,ENVSINDEX AND #FF00/256
                SUB  E
                LD   D,A
                LD  A,(DE)
                ADD A,SOUNDATA AND #00FF
                LD  C,A
                INC  DE
                LD  A,(DE)
                ADC A,SOUNDATA AND #FF00/256
                LD B,A
                RET

;------------------------EVERY 1/50----------------------
PLAY128
TOGLE           LD A,0-0
                XOR 1
                LD (TOGLE+1),A
                JP Z,PART2
PART1           CALL PLAYGEN     ;1ST 50TH
                RET
PART2           CALL ALLREGIST   ;2ND 50TH
                RET

PLAYGEN         LD A,(STORE1+CHANACTIVE)
                OR A
                JR Z,C2
                LD  IX,STORE1
                LD IY,BUFF+8
                LD HL,(BUFF)
                LD (PITCHTEMP),HL
                LD HL,(STORE1+DATAPTR)
                CALL TESTCHAN
                LD (BUFF),HL

C2              LD A,(STORE2+CHANACTIVE)
                OR A
                JR Z,C3
                LD  IX,STORE2
                LD IY,BUFF+9
                LD HL,(BUFF+2)
                LD (PITCHTEMP),HL
                LD HL,(STORE2+DATAPTR)
                CALL TESTCHAN
                LD (BUFF+2),HL

C3              LD A,(STORE3+CHANACTIVE)
                OR A
                JR Z,SUBOCTAVE
                LD IX,STORE3
                LD IY,BUFF+10
                LD HL,(BUFF+4)
                LD (PITCHTEMP),HL
                LD HL,(STORE3+DATAPTR)
                CALL TESTCHAN
                JP NOSUB

SUBOCTAVE       OR H              ;A ALWAYS 0 HERE
                OR L
                JR Z,NOSUB        ;PAUSES
                RL L              ;DOUBLE PERIOD=HALVE FREQUENCY
                RL H
                LD A,(BUFF+9)     ;CH3 VOL= CH2 VOL
                LD (BUFF+10),A
                LD A,(BUFF+7)     ;NO NOISE (C3 NOISEGATE COULD STILL BE OPEN)
                OR  %00100000
                LD (BUFF+7),A

NOSUB           LD (BUFF+4),HL

                CALL DOENSE

                RET

;***************
IF SPECVERSION

ALLREGIST       XOR A
                LD HL,BUFF+10
                LD E,10
NEXTREG         LD BC,65533
                OUT (C),E
                LD BC,49149
                LD A,(HL)
                DEC HL
                OUT (C),A
                DEC E
                JP P,NEXTREG
                RET

ELSE

ALLREGIST       XOR  A
                LD   HL,BUFF+10  ;10
                LD   DE,#F40A    ;10
NEXTREG         LD   B,D
                OUT  (C),E
                LD   BC,63168
                OUT  (C),C
                OUT  (C),A
                LD   B,D
                LD   C,(HL)
                DEC  HL
                OUT  (C),C
                LD   BC,63104
                OUT  (C),C
                OUT  (C),A
                DEC  E
                JP   P,NEXTREG
                RET
ENDIF
;*************

;FOR EACH OF THE 3 CHANNELS:

TESTCHAN     DEC  (IX+MAINCOUNT)
             JP NZ,DOENV_ENT
             LD A,20
             LD (DECI+1),A

DECI         LD A,0-0    ;SELF-MOD
             DEC A
             LD (DECI+1),A
             RET Z
             LD   A,(HL)
             INC  HL
             LD   E,(HL)
             INC HL

SUBSELECT    OR A
             JP   Z,DOPAUSE
             CP   6
             JR   C,STARTLOOP
             CP   101
             JP   C,NEWNOTE
             CP   228
             JP   C,COMPNOTE
             CP   255
             JP   Z,RETCONBLOC
             CP   244
             JR   Z,NEWPRIORITY

             SUB 230
             JR  Z,NOISE
             DEC A
             JR  Z,NOISENOCHECK
             DEC A
             JR  Z,QUICKOUT
             DEC A
             JR  Z,NEWENV
             DEC A
             JR  Z,NEWENT
             DEC A
             JR  Z,NEWENSE
             DEC A
             JP  Z,SETINTERVAL
             DEC A
             JR  Z,NEWKEY
             DEC A
             JR  Z,GONEWBLOC

KILLCHAN        LD (IX+CHANACTIVE),0
                LD (IY+0),0
                RET

NEWPRIORITY     LD (IX+CHANACTIVE),E
                JP DECI

QUICKOUT        LD (IX+MAINCOUNT),1
                DEC HL
                LD (IX+DATAPTR),L
                LD (IX+DATAPTR+1),H
                LD HL,0
                RET

STARTLOOP       PUSH HL
                LD C,A        ;C=CHAN
                CALL STARTASOUND
                POP HL
                JP DECI

NOISE           LD A,(BUFF+7)      ;NO DRUMS IF FX NOISE ON CHAN 3
                AND %00100000
                JR Z,DECI
NOISENOCHECK    LD A,1
                LD (NSEFLAG),A
                LD   A,E
                LD   (BUFF+6),A
                JP   DECI

NEWKEY          LD   (IX+PITCHSHIFT),E
                JP   DECI

NEWENT          CALL FINDENV
                LD (IX+ENTADR),C
                LD (IX+ENTADR+1),B
                JP DECI

NEWENV          CALL FINDENV
                LD (IX+ENVADR),C
                LD (IX+ENVADR+1),B
                JP DECI

NEWENSE         CALL FINDENV
                LD (ENSSTORE+12),BC
                JP DECI

GONEWBLOC       LD   (IX+CONPTR+1),H
                LD   (IX+CONPTR),L
                CALL FINDBLOC
                JP   DECI

RETCONBLOC      LD   H,(IX+CONPTR+1)
                LD   L,(IX+CONPTR)
                LD A,(HL)
                INC A     ;TEST 255
                JP NZ,DECI
                LD H,(IX+PTRREFR+1)
                LD L,(IX+PTRREFR)
                JP DECI

SETINTERVAL     LD (IX+INTERVAL),E
                JP DECI
;--------------
COMPNOTE        AND 127     ;compressor
                DEC HL
                LD E,(IX+CURRENTDUR)

NEWNOTE         ADD  A,(IX+PITCHSHIFT)

;*******
IF SPECVERSION
                SUB 12       ;halve note if spec128 (AY clock 2Mhz)

ENDIF
;*******

DOPAUSE         LD   (IX+MAINCOUNT),E
                LD   (IX+CURRENTDUR),E
                LD   (IX+CURRENTNOTE),A
                LD   (IX+DATAPTR+1),H
                LD   (IX+DATAPTR),L

PITCHTAB        EQU  SOUNDATA
                ADD  A,A
                ADD  A,PITCHTAB AND #00FF
                LD   L,A
                ADC  A,PITCHTAB AND #FF00 /256
                SUB  L
                LD   H,A
                LD   DE,PITCHTEMP
                LDI
                LDI

                LD (IY+0),0

                PUSH IX
                POP  DE
                LD   HL,8
                ADD  HL,DE
                LDI
                LDI
                LDI
                LDI
                LDI
                LDI
                LDI
                LDI

                XOR A
                LD HL,NSEFLAG
                OR  (HL)
                LD (HL),0
                LD   L,(IX+NOISEDIS)
                JR   Z,GATING

NOISEON         LD  HL,(ENSSTORE+ENVADR)
                LD  (ENSSTORE+ENVPTR),HL
                LD  HL,00
                LD  (ENSSTORE),HL

GATING          LD   A,(BUFF+7)
                AND  (IX+CH_ENABLE)
                OR   L
                AND  %00111111
                LD   (BUFF+7),A
;--------------

DOENV_ENT       CALL ENGEN

                LD A,(IY+0)
                ADD A,C
                SUB  128
                LD   (IY+0),A

                LD HL,(PITCHTEMP)
                LD A,H
                OR L
                RET Z
                LD A,(IX+INTERVAL)
                OR A
                JR NZ,DOCHORD
DOENT           INC IX
                INC IX
                CALL ENGEN
                LD HL,(PITCHTEMP)
                LD B,0
;**********
IF SPECVERSION
                ADD  HL,BC
                ADD HL,BC
                LD   C,128
                SBC HL,BC
                SBC  HL,BC
ELSE
                ADD HL,BC
                LD C,128
                SBC HL,BC
ENDIF
;**********
                RET

;--------
DOCHORD         DEC (IX+CHORDTOGGLE)
                LD A,(IX+CURRENTNOTE)
                JR Z,FINDSETPITCH
                ADD (IX+INTERVAL)
                LD (IX+CHORDTOGGLE),1

PITCHTAB        EQU  SOUNDATA
FINDSETPITCH    ADD  A,A
                ADD  A,PITCHTAB AND #00FF
                LD   L,A
                ADC  A,PITCHTAB AND #FF00 /256
                SUB  L
                LD   H,A
                LD   E,(HL)
                INC HL
                LD  D,(HL)
                EX HL,DE
                RET

;-----------
DOENSE      LD IX,ENSSTORE
            CALL ENGEN
            LD HL, BUFF+6
            LD   A,(HL)
            ADD  A,C
            SUB  128
            LD   (HL),A
            CP 17
            RET C
NOISEOFF    INC HL       ;HL=BUFF+7
            LD A,(HL)
            OR %00111000
            LD (HL),A
            RET
;------------
ENGEN       PUSH IX
            POP  HL
            LD   D,(IX+ENVPTR+1)
            LD   E,(IX+ENVPTR)
            INC  (HL)
            LD   A,(DE)
            SUB  (HL)
            LD C,128
            RET  NZ
            LD   (HL),A
            INC DE
            LD  A,(DE)
            LD C,A
            INC  DE
            INC  HL
            INC  (HL)
            LD   A,(DE)
            SUB  (HL)
            RET  NZ
            LD   (HL),A
            INC  DE
            LD   A,(DE)
            INC  A
            JR   NZ,NEXTSECT
            LD   D,(IX+ENVADR+1)
            LD   E,(IX+ENVADR)
NEXTSECT    LD   (IX+ENVPTR+1),D
            LD   (IX+ENVPTR),E
            RET

;--------
BUFF      DW  00
          DW  00
          DW  00
          DB  0
          DB  %00111111
          DB  0
          DB  0
          DB  0
          DB  16,0
          DB  10

PITCHTEMP   DW 00

NSEFLAG     DB 0

ENSSTORE  DW 00
          DW 10
          DW 00
          DW 04
          DW 00
          DW 18
          DW 00

STORE1  DW  00
        DW  00
        DW  00
        DW  00
        DW  00
        DW  00
        DW  00
        DW  00
        DB  0
        DB  0
        DW  00
        DW  00
        DW  00
        DB  0
        DB  8
        DB  32+16+4+2-4 ;CHAN ENABLE  (-4 'COS SUBOCTAVE = CH3 ALWAYS ON)
        DB  0
        DB  0
        DB  0
        DB  0

STORE2  DW  00
        DW  00
        DW  00
        DW  00
        DW  00
        DW  00
        DW  00
        DW  00
        DB  0
        DB  0
        DW  00
        DW  00
        DW  00
        DB  0
        DB  16
        DB  32+8+4+1-4
        DB  0
        DB  0
        DB  0
        DB  0

STORE3  DW  00
        DW  00
        DW  00
        DW  00
        DW  00
        DW  00
        DW  00
        DW  00
        DB  0
        DB  0
        DW  00
        DW  00
        DW  00
        DB  0
        DB  32
        DB  16+8+2+1
        DB  0
        DB  0
        DB  0
        DB  0

SPARE           DW 00

;---------
FINISH          DEFL $
                LIST
                CLOSE
START           DEFL START
FINISH          DEFL FINISH
LENGTH          DEFL FINISH-START
E---------J.Dave Rogers 88------

SPECVERSION  EQU   0                ;0=AMSTRAD 100
        DW  00
        DW  00
        DB  0
        DB  0
        DW  00
        DW  00
        DW  00
        DB  0
        DB  32
        DB  16+8+2+1
        DB  0
        DB  0
        DB  0
        DB  0

SPARE           DW 00

;-