;CYBER2SD.ASM      CYBERNOID 2 sound driver       J.Dave Rogers  1988

;*************************************
SPECVERSION     EQU       0             ;1 FOR SPECTRUM,0 FOR AMSTRAD
SOUNDCOD        EQU       28000         ;machine code address.
SOUNDATA        EQU       soundcod+881  ;datablock address.
;*************************************

             NOLIST

ENVSINDEX    EQU       soundata+200
TUNESINDEX   EQU       ENVSINDEX+80

envcounts    EQU 0
entcounts    EQU 2
envptr       EQU 4
entptr       EQU 6
env0         EQU 8
ent0         EQU 10
envadr       EQU 12
entadr       EQU 14

chanactive   EQU 16   ;1
maincount    EQU 17   ;1
dataptr      EQU 18   ;2
conptr       EQU 20   ;2
ptrrefr      EQU 22   ;2
pitchshift   EQU 24   ;1
noiseflag    EQU 25   ;1
noisedis     EQU 26   ;1
ch_enable    EQU 27   ;1
advolreg     EQU 28   ;2
stophang     EQU 30   ;1
CURRENTDUR   EQU 31   ;1
INTERVAL     EQU 32   ;1
CURRENTNOTE  EQU 33   ;1
CHORDTOGGLE  EQU 34   ;1

             ORG  SOUNDCOD
             WRITE "CYBER2SD.BIN"
start        DEFL $

;-----------------------------------------------
JUMPBLOCK       JP PLAY          ;used for convenience in Basic Demos
                JP SILENCE
BASIC_DEMO      LD E,1
                LD A,1

;-------------------------------------------------
STARTACHAN      LD C,A             ; a/c=chan num e=tuneblock num
                CALL FINDBLOC      ; 1. PUT BLOCK ADDRESS IN HL, GIVEN E
                LD A,(HL)          ; 2. LOOK FOR START CHANNEL MARKER
                CP 9
                JR NC,nochanmarker
                LD C,A
                INC HL
                LD A,(HL)         ; 5. LOOK FOR SPECIAL PRIORITY,ELSE DEFAULT 10
NOCHANMARKER    CP 244
                LD B,10
                JR NZ, CH1TO3
                INC HL
                LD B,(HL)
                INC HL        ;C NOW CHAN   B NOW PRIORITY

CH1TO3          LD IX,STORE1       ; 4. FIND IX FOR NEW CHAN
                DEC C
                JR Z ,IXfound
                LD IX,STORE2
                DEC C
                JR Z,IXfound
                LD IX,STORE3
                DEC C
                JR Z,IXFOUND
CHANALT         LD A,(STORE1+CHANACTIVE)     ;CH4= 1 / 2
                OR A
                LD IX,STORE1
                JR Z,IXFOUND        ;CH1 FREE
                LD IX,STORE2        ;USE CH2
IXFOUND
TRYSTART        LD A,B
                CP (IX+CHANACTIVE)   ; 6. TEST AGAINST CURRENT PRIORITY
                RET C
DOSTART         XOR A
                LD (IX+CHANACTIVE),A   ; 7. off while set up!
                LD (IX+DATAPTR),L       ;set pointers for this channel
                LD (IX+DATAPTR+1),H
                LD (IX+CONPTR),L
                LD (IX+CONPTR+1),H
                LD (IX+PTRREFR),L
                LD (IX+PTRREFR+1),H

                LD (IX+MAINCOUNT),1
                LD (IX+PITCHSHIFT),A
                LD (IX+INTERVAL),A
                 LD (IX+CHANACTIVE),B     ;activate
                RET

;-------------------------------------
SILENCE         XOR A
                LD  (STORE1+CHANACTIVE),A
                LD  (STORE2+CHANACTIVE),A
                LD  (STORE3+CHANACTIVE),A
                LD (BUFF+8),A              ;volume registers 0
                LD (BUFF+9),A
                LD (BUFF+10),A
                LD   A,1+2+4+8+16+32       ;all gates shut
                LD   (BUFF+7),A
                JP ALLREGIST               ;RETS FROM THERE

;-------------------------subroutines
FINDBLOC        LD   A,E
                ADD  A,A
                ADD  A,TUNESINDEX AND #00FF
                LD   L,A
                ADC  A,TUNESINDEX AND #FF00 /256
                SUB  L
                LD   H,A         ;HL now points to 2byte value in table
                LD   E,(HL)
                INC  HL
                LD   D,(HL)      ;DE=value(offset FROM START OF SOUNDATA)
                LD HL,soundata
                ADD HL,DE        ;HL=address of new tunebloc
                RET

FINDENV         LD   A,E
                ADD  A,A
                ADD  A,ENVSINDEX AND #00FF
                LD   E,A
                ADC  A,ENVSINDEX AND #FF00 / 256
                SUB  E
                LD   D,A

                LD  A,(DE)
                ADD A,SOUNDATA AND #00FF
                LD  C,A

                INC  DE
                LD  A,(DE)
                ADC A,SOUNDATA AND #FF00 / 256
                LD B,A

                RET

;-------------------MAIN CALL--------EVERY 1/50 SECOND-----------------------

PLAY            LD  IX,STORE1     ;---do channel 1 (IX points to chan1 store)
                LD HL,(BUFF)
                CALL TESTCHAN
                LD HL,(PITCHTEMP)
                LD (BUFF),HL

                LD HL, (BUFF+2)
                LD  IX,STORE2     ;---do channel 2
                CALL TESTCHAN
                LD HL,(PITCHTEMP)
                LD (BUFF+2),HL

                LD HL,(BUFF+4)
                LD   IX,STORE3     ;---do channel 3
                CALL TESTCHAN
                LD HL,(PITCHTEMP)
                LD (BUFF+4),HL

                CALL DOENSE        ;do noise envelope
;********************
IF SPECVERSION

ALLREGIST       XOR A
                LD HL,BUFF+13
                LD E,13
NEXTREG         LD BC,65533
                OUT (C),E
                LD BC,49149
                LD A,(HL)
                DEC HL
                OUT (C),A
                DEC E
                JP P,NEXTREG
ELSE

ALLREGIST       XOR  A
                LD   HL,BUFF+13            ;registers buffer
                LD   DE,#F40D              ;D=Psg data port, E=loop counter
nextreg         LD   B,D
                OUT  (C),E
                LD   BC,#F6*256+%11000000
                OUT  (C),C
                OUT  (C),A
                LD   B,D
                LD   C,(HL)
                DEC  HL
                OUT  (C),C
                LD   BC,#F6*256+%10000000
                OUT  (C),C
                OUT  (C),A
                DEC  E
                JP   P,nextreg
ENDIF
;**************************
                RET                   ;-------------->>>>>>> out

;FOR EACH OF THE 3 CHANNELS:

TESTCHAN        LD (PITCHTEMP),HL
                LD  A,(IX+CHANACTIVE)  ;CHAN ACTIVE?
                OR A
                RET Z                  ;do nothing if channel not active
                DEC  (IX+maincount)    ;duration countdown, new note when 0
                JP NZ,DOENV_ENT
                LD A,20
                LD (DECI+1),A

                LD  H,(IX+dataptr+1)   ;get data ptr address
                LD  L,(IX+DATAPTR)

DECI            LD A,0-0
                DEC A
                LD (DECI+1),A          ;SELF-MOD
                RET Z

                LD   A,(HL)            ;A=peek(ptr)
                INC  HL
                LD   E,(HL)            ;E=peek(ptr+1)
                INC HL                 ;inc and store ptr for next time

;-----------------------
SUBSELECT  CP   0             ;A=VALUE
           JP   Z,DOPAUSE     ;pitch 0 = pause
           CP  9
           JR  C,STARTLOOP   ;<9 = CHAN to start, FOLLOWED BY BLOC num
           CP   101
           JP   C,NEWNOTE     ;LESS THAN 100=normal note
           CP   127
           JR   C,NOISE      ;102 TO 127 NOISE K TO X
           CP   223
           JP   C, COMPNOTE   ;128 TO 223 COMPRESSED NOTES
           CP  227
           JP  Z,PLAYRAND     ;PLAY FROM RANDNOTE STORE(+PITCHSHIFT)
           CP   225
           JP   Z,KILLCHAN    ;shut chan after e.g.short sound effects
           CP   233
           JR   Z,NEWENT      ;set new tone-envelope for current channel
           CP   232
           JR   Z,NEWENV      ;set new volume-env for current chan
           CP   234
           JR   Z,NEWENSE     ;set new noise-envelope
           CP  226
           JP  Z,NEWRANDNOTE  ;226/ander. RANDnote = rnd*255 AND ANDER
           CP   229
           JR   Z,GONEWBLOCK  ;play a given tunebloc,then return to 1st
           CP   230
           JP   Z,NEWKEY      ;change musical key for current chan
           CP  240
           JR  Z,SETINTERVAL
           CP   255
           JR   Z,RETCONBLOC  ;end-of-tunebloc marker

           JR DECI            ;SAFETY NET

KILLCHAN        LD (IX+CHANACTIVE),0
killvol         LD H,(IX+ADVOLREG+1)
                LD L,(IX+ADVOLREG)    ;HL=address of vol register,current chan
                LD (HL),0
                RET


STARTLOOP       PUSH HL
                PUSH IX           ;A=CHAN E=TUNEBLOC
                CALL STARTACHAN
                POP IX
                POP HL
                JR DECI

NOISE           SUB 102
                LD   (BUFF+6),A        ;noisepitch
                LD   (IX+noiseflag),1
                DEC HL
                JP   DECI

NEWKEY          LD   (IX+pitchshift),E
                JP   DECI

NEWENT          CALL FINDENV       ;returns with envelope address in BC
                LD (IX+ENTADR),C
                LD (IX+ENTADR+1),B
                JP DECI

NEWENV          CALL FINDENV
                LD (IX+ENVADR),C
                LD (IX+ENVADR+1),B
                JP DECI

NEWENSE         CALL FINDENV
                LD (ENSSTORE+12),BC
                JP DECI

GONEWBLOCK      LD   (IX+conptr+1),H
                LD   (IX+conptr),L    ;leaving bloc so store ptr
                CALL FINDBLOC
                JP   DECI

RETCONBLOC      LD   H,(IX+conptr+1)  ;(ptr re-enters original "conductor" bloc)
                LD   L,(IX+conptr)
                LD   A,(HL)
                INC A                 ;TEST FOR 255,end-of-conductor-bloc marker
                JR   NZ,NOTEND
                LD   H,(IX+ptrrefr+1) ;refresh
                LD   L,(IX+ptrrefr)
notend          JP   DECI

SETINTERVAL     LD (IX+INTERVAL),E
                JP DECI

NEWRANDNOTE     PUSH HL
                LD HL,10418  ;RANDSEED,SELF MOD LATER
                LD C,L
                LD B,H
                ADD HL,HL
                ADD HL,HL
                ADD HL,BC
                ADD HL,HL
                ADD HL,HL
                ADD HL,HL
                ADD HL,BC
                LD (NEWRANDNOTE+2),HL
                LD A,H               ;A=0 TO 255
                AND E                ;E = ANDER = range limiter
                INC A                ;A=1 to (0 gives pause!)
                LD (PLAYRAND+1),A
                POP HL
                JP DECI

COMPNOTE        AND 127
                DEC HL
                LD E,(IX+CURRENTDUR)
                JP NEWNOTE

PLAYRAND        LD A,42   ;SELF MODIFIED VALUE

NEWNOTE         ADD  A,(IX+pitchshift)   ;A=notenum

;**********
IF SPECVERSION
                SUB 12
ENDIF
;**********

DOPAUSE         LD   (IX+maincount),E    ;E=duration
                LD (IX+CURRENTNOTE),A    ;for chorder
                LD (IX+CURRENTDUR),E     ;FOR COMPRESSOR

                LD (IX+DATAPTR+1),H
                LD (IX+DATAPTR),L

                CALL FINDSETPITCH

                LD H, (IX+ADVOLREG+1)
                LD L, (IX+ADVOLREG)
                LD (HL),0

                PUSH IX           ;RESTART ENV/ent
                POP  DE           ;DE=start of chan store
                LD   HL,8
                ADD  HL,DE        ;HL=start of chan store+8
                LDI
                LDI
                LDI
                LDI
                LDI
                LDI
                LDI
                LDI

                DEC  (IX+noiseflag)      ;test noiseflag
                LD  (IX+NOISEFLAG),0     ;RESET EVERY TIME!
                LD  L,(IX+NOISEDIS)      ;DEFAULT DISABLE
                JR   NZ,GATING

NOISEon         LD HL,(ENSSTORE+envadr)  ;restart noise envelope
                LD (ENSSTORE+envptr),HL
                LD HL,00
                LD (ENSSTORE),HL         ;L=0,no noisedisable

GATING          LD   A,(BUFF+7)
                AND  (IX+ch_enable)      ;chan ENable (pitch AND noise on)
                OR   L                   ;noise DISable
                AND 32+16+8+4+2+1        ;SAFETY, top 2 bits must remain off
                LD   (BUFF+7),A          ;FINAL RESULT IN A!
;------------------------------------
                           ;IX points to volume-env workspace for current chan
DOENV_ENT       CALL ENGENERAL         ;returns with "volume change+128" in C
                LD   H,(IX+advolreg+1)
                LD   L,(IX+advolreg)
                LD   A,(HL)
                ADD  A,C
                SUB  128
                LD   (HL),A

ISITAPAUSE      LD HL,(PITCHTEMP)
                LD A,H
                OR L
                RET Z
ISITACHORD      LD A,(IX+interval)
                OR A
                JR NZ,DOCHORD
DOENT           INC  IX  ;make IX work on tone-envelope workspace,2 bytes along
                INC  IX
                CALL ENGENERAL   ;returns with "pitch change+128" in C
                LD HL,(PITCHTEMP)
                LD B,0
;*******************
IF SPECVERSION
                ADD HL,BC
                ADD HL,BC
                LD C,128
                SBC HL,BC
                SBC HL,BC
ELSE
                ADD  HL,BC
                LD   C,128       ;deduct 128, allows negative changes
                SBC  HL,BC
ENDIF
;*******************:
                LD (PITCHTEMP),HL
                RET

DOCHORD         DEC (IX+CHORDTOGGLE)
                LD A,(IX+CURRENTNOTE)
                JR Z,FINDSETPITCH
                ADD (IX+INTERVAL)
                LD (IX+CHORDTOGGLE),1

pitchtab        equ  soundata
FINDSETPITCH    ADD  A,A                     ;get new pitch from pitchtable
                ADD  A,PITCHTAB AND #00FF
                LD   L,A
                ADC  A,PITCHTAB AND #FF00 /256
                SUB  L
                LD   H,A      ;HL=ADR OF PITCH IN TABLE

                LD   DE,PITCHTEMP   ;DE=DESTINATION
                LDI                  ;PEEK(HL) > PEEK(DE)
                LDI
                RET

DOENSE          LD   IX,ENSSTORE  ;IX now = noise envelope workspace
                CALL ENGENERAL    ;returns with "noise shift+128" in C
                LD HL, BUFF+6
                LD   A,(HL)   ;get current noise value
                ADD  A,C
                SUB  128          ;add shift, minus 128
                LD   (HL),A   ;replace
                CP 17
                RET C
noiseoff        INC HL     ;HL=buff+7
                LD A,(HL)
                OR 32+16+8
                LD (HL),A
                RET

;------------------------
ENGENERAL       PUSH IX       ;(subroutine to do envelope and return value)
                POP  HL                ;points to counts
                LD   D,(IX+ENVPTR+1)   ;points to envelope
                LD   E,(IX+ENVPTR)
                INC  (HL)     ;inc count
                LD   A,(DE)
                SUB  (HL)     ;compare to envelope
                LD   C,128    ;DEFAULT (C= 128 = 0 )
                RET  NZ       ;count not reached
                LD   (HL),A   ;A=0, resets count
                INC DE        ;move along envelope
                LD  A,(DE)
                LD  C,A       ;C HOLDS INCREMENT
                INC  DE       ;point at repeats number
                INC  HL
                INC  (HL)     ;point at repeats count
                LD   A,(DE)
                SUB  (HL)     ;compare
                RET  NZ       ;count not reached
                LD   (HL),A   ;A=0, resets count;
                INC  DE       ;move to next section of envelope
                LD   A,(DE)
                INC  A        ;test for A=255 (end of envelope marker)
                JR   NZ,nextsect
                LD   D,(IX+envadr+1)   ;refresh ptr to start of envelope
                LD   E,(IX+envadr)
nextsect        LD   (IX+envptr+1),D
                LD   (IX+envptr),E
                RET
;--------------------------------------------------------

BUFF      DW  00       ;a pitch     ;holds replica of sound chip registers
          DW  00       ;b pitch
          DW  00       ;c pitch
          DB  0        ;noise pitch
          DB  32+16+8  ;gates
          DB  0        ;a vol
          DB  0        ;b vol
          DB  0        ;c vol
          DW  100      ;hard env len
          DB  10       ;hard env type

PITCHTEMP  DW 00

ensstore  DW 00 ;ENSCOUNTS    ;noise envelope workspace
          DW 10               ;dummy spacer to give same format as chan stores
          DW 00 ;ENSPTR
          DW 04
          DW 00 ;ENS0
          DW 18
          DW 00 ;ENSADR
;----------------------------------
;channel stores

STORE1    DW  00     ;env counts
          DW  00     ;ENT COUNTS
          DW  00     ;ENV PTR
          DW  00     ;ENT PTR

          DW  00     ;ENV ZEROERS
          DW  00     ;ENT ZEROERS
          DW  00     ;ENV ADDR
          DW  00     ;ENT ADDR

          DB  0      ;CHAN ACTIVE
          DB  0      ;MAIN COUNT
          DW  00     ;MAIN PTR
          DW  00     ;CON PTR
          DW  00     ;PTR REFRESH
          DB  0      ;PITCHSHIFT
          DB  0      ;NOISE FLAG
          DB   8        ;NOISE DIS
          DB  32+16+4+2 ;chan ENable
          DW  BUFF+8    ;AD OF VOL REG
          DB  0
          DB  0      ;CURRENTDUR (FOR COMPRESSOR)
          DB  0
          DB  0
          DB  0

STORE2  DW  00
        DW  00
        DW  00
        DW  00

        DW  00
        DW  00
        DW  00
        DW  00

        DB  0
        DB  0
        DW  00
        DW  00
        DW  00
        DB  0
        DB  0
        DB  16        ;NOISE DIS
        DB  32+8+4+1  ;chan ENable
        DW  BUFF+9    ;AD OF VOL REg
        DB  0
        DB  0
        DB  0
        DB  0
        DB  0

STORE3  DW  00
        DW  00
        DW  00
        DW  00

        DW  00
        DW  00
        DW  00
        DW  00

        DB  0
        DB  0
        DW  00
        DW  00
        DW  00
        DB  0
        DB  0
        DB  32       ;NOISE DIS
        DB  16+8+2+1 ;CHAN ENABLE
        DW  BUFF+10  ;AD OF VOL REG
        DB  0
        DB  0
        DB  0
        DB  0
        DB  0

        DB 42     ;SPARE
;------------------------------------------------
FINISH          DEFL $
                LIST
                CLOSE
START           DEFL START
FINISH          DEFL FINISH
LENGTH          DEFL FINISH-START
OID 2     J.Dave Rogers    1988

;*************************************
SPECVERSION     EQU     DB  32       ;NOISE DIS
        DB  16+8+2+1 ;CHAN ENABLE
        DW  BUFF+10  ;AD OF VOL REG
        DB  0
        DB  0
        DB  0
        DB  0
        DB  0

        DB 42     ;SPARE
;------------------------------------------------
FINISH          DEFL $
                LIST
                CLOSE
START           DEFL START
FINISH          DEFL FINISH
LENGT