;NEBULUSD.ASM     NEBULUS Sound driver (AMSTRAD)   ***** VERSION  5.0 *****


SOUNDCOD     EQU       28000            ;MACHINE CODE
SOUNDATA     EQU       SOUNDCOD + #3A2  ;DATABLOCK LOAD

             NOLIST

ENVSINDEX    EQU       SOUNDATA+200
TUNESINDEX   EQU       ENVSINDEX+80

ENVCOUNTS    EQU 0    ;OFFSETS WITHIN CHANNEL STORES:
ENTCOUNTS    EQU 2
ENVPTR       EQU 4
ENTPTR       EQU 6
ENV0         EQU 8
ENT0         EQU 10
ENVADR       EQU 12
ENTADR       EQU 14

CHANACTIVE   EQU 16   ;1
MAINCOUNT    EQU 17   ;1
DATAPTR      EQU 18   ;2
CONPTR       EQU 20   ;2

  ;2 REMOVED

PITCHSHIFT   EQU 22   ;1
  ; 1 REMOVED
NOISEDIS     EQU 23   ;1
CH_ENABLE    EQU 24   ;1

  ;4 REMOVED

INTERVAL     EQU 25   ;1
CURRENTNOTE  EQU 26   ;1
CHORDTOGGLE  EQU 27   ;1

             ORG  SOUNDCOD
             WRITE "NEBULUSD.BIN"
START        DEFL $

;--------------------------------------
JUMPBLOCK:      JP PLAY
                JP SILENCE
                LD E,1
                LD A,1
;-------------------------------------------------

STARTACHAN:     DI
                LD C,A              ; A/C=CHAN NUM E=TUNEBLOCK NUM
                CALL FINDBLOC       ; 1. PUT BLOCK ADDRESS IN HL, GIVEN E
                LD A,(HL)           ; 2. LOOK FOR START CHANNEL MARKER
                CP 4
                JR Z,CHANALT
                CP 9
                JR NC,NOCHANMARKER
                LD C,A
                INC HL
NOCHANMARKER:   LD A,C
                DEC A
                JR Z ,CH1
                DEC A
                JR Z,CH2
                JP   CH3

CHANALT:        INC HL
                LD A,(STORE2+CHANACTIVE) ;ch2 = 1st choice (gets chorused)
                OR A
                JR Z,CH2
                LD A,(STORE1+CHANACTIVE) ;ch1 = 2nd choice (mono)
                OR A
                JR Z,CH1
CH3:            XOR A                    ;ch3 = last resort. Stops chorus of
                LD (STORE3+INTERVAL),A   ;other chan. (Only choice if tune is
                INC A                    ;playing)
                LD (STORE3+MAINCOUNT),A
                LD (STORE3+DATAPTR),HL
                LD (STORE3+CHANACTIVE),A
                EI
                RET
CH2:            LD (STORE2+INTERVAL),A
                INC A
                LD (STORE2+MAINCOUNT),A
                LD (STORE2+DATAPTR),HL
                LD (STORE2+CHANACTIVE),A
                EI
                RET
CH1:            LD (STORE1+INTERVAL),A
                INC A
                LD (STORE1+MAINCOUNT),A
                LD (STORE1+DATAPTR),HL
                LD (STORE1+CHANACTIVE),A
                EI
                RET

;-------------------------------------
SILENCE:        DI
                LD A,1+2+4+8+16+32
                LD (BUFF+7),A              ;ALL GATES SHUT
                XOR A
                LD  (STORE1+CHANACTIVE),A  ;CHANNEL-ACTIVE-FLAGS 0
                LD  (STORE2+CHANACTIVE),A
                LD  (STORE3+CHANACTIVE),A
                LD (STORE1+INTERVAL),A     ;ZEROED FOR "CHANALT" SOUND FX
                LD (STORE2+INTERVAL),A
                LD (STORE3+INTERVAL),A
                LD (STORE1+PITCHSHIFT),A
                LD (STORE2+PITCHSHIFT),A
                LD (STORE3+PITCHSHIFT),A
                LD (BUFF+8),A              ;VOLUME REGISTERS 0
                LD (BUFF+9),A
                LD (BUFF+10),A

ALL13REGS:      LD HL,BUFF+13              ;A STILL = 0
                LD DE,#F40D                ;13
                JP NEXTREG

;-------------------------SUBROUTINES
FINDBLOC:       LD   A,E
                ADD  A,A
                ADD  A,TUNESINDEX AND #00FF
                LD   L,A
                ADC  A,TUNESINDEX AND #FF00 /256
                SUB  L
                LD   H,A
                LD   E,(HL)
                INC  HL
                LD   D,(HL)
                LD HL,SOUNDATA
                ADD HL,DE
                RET

FINDENV:        LD   A,E
                ADD  A,A
                ADD  A,ENVSINDEX AND #00FF
                LD   E,A
                ADC  A,ENVSINDEX AND #FF00 / 256
                SUB  E
                LD   D,A

                LD  A,(DE)
                ADD A,SOUNDATA AND #00FF
                LD  C,A

                INC  DE
                LD  A,(DE)
                ADC A,SOUNDATA AND #FF00 / 256
                LD B,A
                RET

;-------------------MAIN CALL--------EVERY 1/50 SECOND-----------------------

PLAY:           LD HL,STOPHANG
                LD (HL),20

                LD A,(STORE1+CHANACTIVE)
                OR A
                JR Z,C2
                LD  IX,STORE1      ;---DO CHANNEL 1 (IX POINTS TO CHAN1 STORE)
                LD IY,BUFF+8
                LD HL,(BUFF)       ;CURRENT PITCH
                LD (PITCHTEMP),HL
                LD HL,(STORE1+DATAPTR)
                CALL TESTCHAN
                LD (BUFF),HL

C2:             LD A,(STORE2+CHANACTIVE)
                OR A
                JR Z,C3
                LD  IX,STORE2      ;---DO CHANNEL 2
                LD IY,BUFF+9
                LD HL,(BUFF+2)
                LD (PITCHTEMP),HL
                LD HL,(STORE2+DATAPTR)
                CALL TESTCHAN
                LD (BUFF+2),HL

C3:             LD A,(STORE3+CHANACTIVE)
                OR A
                JR Z,CHORUS

                LD   IX,STORE3     ;---DO CHANNEL 3
                LD IY,BUFF+10
                LD HL,(BUFF+4)
                LD (PITCHTEMP),HL
                LD HL,(STORE3+DATAPTR)
                CALL TESTCHAN
                JP NOCHORUS

CHORUS:         OR H    ;A ALWAYS 0 HERE
                OR L
                JR Z,NOCHORUS     ;PAUSES
                DEC L
                DEC L         ;NO PITCH VALS NEAR 256 BOUNDARIES
                LD A,(BUFF+9)
                LD (BUFF+10),A
NOCHORUS:       LD (BUFF+4),HL

                CALL DOENSE

ALLREGIST:      XOR  A
                LD   HL,BUFF+10            ;10
                LD   DE,#F40A              ;10
NEXTREG:        LD   B,D
                OUT  (C),E                 ;OUTPUT REGISTER NO
                LD   BC,63168           ;(#F6*256+%11000000)
                OUT  (C),C                 ;TELL PSG TO LATCH REG NO
                OUT  (C),A                 ;PSG TO INACTIVE
                LD   B,D
                LD   C,(HL)                ;C=REGISTER DATA
                DEC  HL
                OUT  (C),C                 ;OUTPUT REGISTER DATA
                LD   BC,63104           ;(#F6*256+%10000000)
                OUT  (C),C                 ;TELL PSG TO READ REG DATA
                OUT  (C),A                 ;PSG TO INACTIVE
                DEC  E
                JP   P,NEXTREG
                RET                ;-------------->>>>>>> OUT

;FOR EACH OF THE 3 CHANNELS:

TESTCHAN:       DEC  (IX+MAINCOUNT)
                JP NZ,DOENV_ENT

DECI:           LD   A,(HL)         ;A=(PTR)
                INC  HL
                LD   E,(HL)         ;E=(PTR+1)
                INC HL
;-----------------------

SUBSELECT:   OR   A
             JP   Z,DOPAUSE
             CP   9
             JP   C,STARTLOOP
             CP   101
             JP   C,NEWNOTE

           SUB 230         ;VALS NOW SEQUENTIAL TO ALLOW DEC A
           JR  Z,NOISE
           DEC A
           JR  Z,NOISENOCHECK
           DEC A
           JR  Z,QUICKOUT
           DEC A
           JR  Z,NEWENV
           DEC A
           JR  Z,NEWENT
           DEC A
           JR  Z,NEWENSE
           DEC A
           JP  Z,SETINTERVAL
           DEC A
           JR  Z,NEWKEY
           DEC A
           JR  Z,GONEWBLOC
           DEC A
           JR  Z,RETCONBLOC

          ;FOLLOW THROUGH=SAFETY NET
KILLCHAN:       LD (IX+CHANACTIVE),0
                LD (IY+0),0
                RET

QUICKOUT:       LD (IX+MAINCOUNT),1     ;TIME SHARER
                DEC HL
                LD (IX+DATAPTR),L
                LD (IX+DATAPTR+1),H
                LD HL,0
                RET

STARTLOOP:      PUSH IX                 ;A=CHAN E=TUNEBLOC
                PUSH HL
                LD HL,STOPHANG     ;JUST-IN-CASE!
                DEC (HL)
                RET Z
                CALL STARTACHAN
                POP HL
                POP IX
                JP DECI

NOISE:          LD A,(STORE3+CHANACTIVE)   ;NO TUNE-DRUMS IF CH3 ACTIVE
                OR A
                JR NZ, DECI
NOISENOCHECK:   LD   A,E
                LD   (BUFF+6),A            ;NOISEPITCH
                LD A,1
                LD   (NSEFLAG),A
                JP   DECI

NEWKEY:         LD   (IX+PITCHSHIFT),E
                JP   DECI

NEWENT:         CALL FINDENV       ;RETURNS WITH ENVELOPE ADDRESS IN BC
                LD (IX+ENTADR),C
                LD (IX+ENTADR+1),B
                JP DECI

NEWENV:         CALL FINDENV
                LD (IX+ENVADR),C
                LD (IX+ENVADR+1),B
                JP DECI

NEWENSE:        CALL FINDENV
                LD (ENSSTORE+12),BC
                JP DECI

GONEWBLOC:      LD   (IX+CONPTR+1),H
                LD   (IX+CONPTR),L
                CALL FINDBLOC
                JP   DECI

RETCONBLOC:     LD   H,(IX+CONPTR+1)
                LD   L,(IX+CONPTR)
                JP DECI

SETINTERVAL:    LD (IX+INTERVAL),E
                JP DECI


NEWNOTE:        ADD  A,(IX+PITCHSHIFT)

DOPAUSE:        LD   (IX+MAINCOUNT),E
                LD   (IX+CURRENTNOTE),A
                LD   (IX+DATAPTR+1),H
                LD   (IX+DATAPTR),L

PITCHTAB        EQU  SOUNDATA

                ADD  A,A
                ADD  A,PITCHTAB AND #00FF
                LD   L,A
                ADC  A,PITCHTAB AND #FF00 /256
                SUB  L
                LD   H,A                 ;HL=ADR OF PITCH IN TABLE
                LD   DE,PITCHTEMP
                LDI
                LDI

                LD (IY+0),0

                PUSH IX                  ;RESTART ENV/ent
                POP  DE                  ;DE=START OF CHAN STORE
                LD   HL,8
                ADD  HL,DE               ;HL=START OF CHAN STORE+8
                LDI
                LDI
                LDI
                LDI
                LDI
                LDI
                LDI
                LDI

                XOR A
                LD HL,NSEFLAG
                OR   (HL)                  ;TEST NOISEFLAG
                LD   (HL),0                ;RESET EVERY TIME!
                LD   L,(IX+NOISEDIS)       ;DEFAULT DISABLE
                JR   Z,GATING

NOISEON:        LD  HL,(ENSSTORE+ENVADR)   ;RESTART NOISE ENVELOPE
                LD  (ENSSTORE+ENVPTR),HL
                LD  HL,00
                LD  (ENSSTORE),HL          ;L=0,NO NOISEDISABLE

GATING:         LD   A,(BUFF+7)
                AND  (IX+CH_ENABLE)     ;CHAN ENABLE (PITCH AND NOISE ON)
                OR   L                  ;NOISE DISABLE
                AND  32+16+8+4+2+1      ;SAFETY, TOP 2 BITS MUST REMAIN OFF
                LD   (BUFF+7),A         ;FINAL RESULT IN A
;------------------------------------

DOENV_ENT:      PUSH IX
                POP  HL
                LD   D,(IX+ENVPTR+1)
                LD   E,(IX+ENVPTR)
                INC  (HL)
                LD   A,(DE)
                SUB  (HL)
                JP  NZ,NOENV
                LD   (HL),A
                INC DE
                LD  A,(DE)

                ADD (IY+0)
                SUB  128
                LD   (IY+0),A

                INC  DE
                INC  HL
                INC  (HL)
                LD   A,(DE)
                SUB  (HL)
                JP  NZ,NOENV    ;*****
                LD   (HL),A
                INC  DE
                LD   A,(DE)
                INC  A
                JP   NZ,NEXTSECT
                LD   D,(IX+ENVADR+1)
                LD   E,(IX+ENVADR)
NEXTSECT:       LD   (IX+ENVPTR+1),D
                LD   (IX+ENVPTR),E

;-----------------
NOENV:          LD HL,(PITCHTEMP)   ;IS IT A PAUSE ?
                LD A,H
                OR L
                RET Z
                LD A,(IX+INTERVAL)  ;IS IT A CHORD ?
                OR A
                JR NZ,DOCHORD
DOENT:          PUSH IX
                POP  HL
                INC HL
                INC HL
                LD   D,(IX+ENTPTR+1)
                LD   E,(IX+ENTPTR)
                INC  (HL)
                LD   A,(DE)
                SUB  (HL)
                JP  NZ,NOPITCH
                LD   (HL),A
                INC DE
                LD  A,(DE)
                LD  C,A
                INC  DE
                INC  HL
                INC  (HL)
                LD   A,(DE)
                SUB  (HL)
                JP  NZ,DOPITCH
                LD   (HL),A
                INC  DE
                LD   A,(DE)
                INC  A
                JP   NZ,NEXTSECT2
                LD   D,(IX+ENTADR+1)
                LD   E,(IX+ENTADR)
NEXTSECT2:      LD   (IX+ENTPTR+1),D
                LD   (IX+ENTPTR),E

DOPITCH:        LD HL,(PITCHTEMP)
                LD B,0
                ADD  HL,BC
                LD   C,128
                SBC  HL,BC       ;HL=NEW PITCH
GETOUT:         RET

NOPITCH:        LD HL,(PITCHTEMP)
                RET

DOCHORD:        DEC (IX+CHORDTOGGLE)
                LD A,(IX+CURRENTNOTE)
                JR Z,FINDSETPITCH
                ADD (IX+INTERVAL)
                LD (IX+CHORDTOGGLE),1

PITCHTAB        EQU  SOUNDATA

FINDSETPITCH:   ADD  A,A
                ADD  A,PITCHTAB AND #00FF
                LD   L,A
                ADC  A,PITCHTAB AND #FF00 /256
                SUB  L
                LD   H,A   ;HL=ADR OF PITCH IN TABLE

                LD   E,(HL)
                INC HL
                LD  D,(HL)
                EX HL,DE
                RET
;---------------------
DOENSE:         LD DE,(ENSSTORE+4)
                LD HL,ENSSTORE
                INC  (HL)
                LD   A,(DE)
                SUB  (HL)
                RET  NZ
                LD   (HL),A
                INC DE
                LD  A,(DE)
                LD  C,A
                INC  DE
                INC  HL
                INC  (HL)
                LD   A,(DE)
                SUB  (HL)
                JP  NZ,DONSE
                LD   (HL),A
                INC  DE
                LD   A,(DE)
                INC  A
                JP   NZ,NEXTSECT3
                LD   DE,(ENSSTORE+12)
NEXTSECT3:      LD   (ENSSTORE+4),DE

DONSE:          LD HL, BUFF+6
                LD   A,(HL)
                ADD  A,C
                SUB  128
                LD   (HL),A
                CP 17
                RET C
NOISEOFF:       INC HL    ;HL=BUFF+7
                LD A,(HL)
                OR 32+16+8
                LD (HL),A
                RET

;---------------------

BUFF:     DW  00       ;A PITCH
          DW  00       ;B PITCH
          DW  00       ;C PITCH
          DB  0        ;NOISE PITCH
          DB  32+16+8  ;GATES
          DB  0        ;A VOL
          DB  0        ;B VOL
          DB  0        ;C VOL
          DB  255,255  ;HARD ENV LEN
          DB  12       ;HARD ENV TYPE

PITCHTEMP:  DW 00

NSEFLAG:    DB 0

STOPHANG:   DB 0

ENSSTORE: DW 00 ;ENSCOUNTS
          DW 10
          DW 00 ;ENSPTR
          DW 04
          DW 00 ;ENS0
          DW 18
          DW 00 ;ENSADR
;----------------------------------
;CHANNEL STORES

STORE1:   DW  00     ;ENV COUNTS
          DW  00     ;ENT COUNTS
          DW  00     ;ENV PTR
          DW  00     ;ENT PTR

          DW  00     ;ENV ZEROERS
          DW  00     ;ENT ZEROERS
          DW  00     ;ENV ADDR
          DW  00     ;ENT ADDR

          DB  0      ;CHAN ACTIVE
          DB  0      ;MAIN COUNT
          DW  00     ;MAIN PTR
          DW  00     ;CON PTR
          DB  0      ;PITCHSHIFT
          DB   8        ;NOISE DIS
          DB  32+16+4+2-4 ;CHAN ENABLE  (-4 'COS CHORUS=CH3 ALWAYS ON)
          DB  0
          DB  0
          DB  0

STORE2: DW  00
        DW  00
        DW  00
        DW  00

        DW  00
        DW  00
        DW  00
        DW  00

        DB  0
        DB  0
        DW  00
        DW  00
        DB  0
        DB  16
        DB  32+8+4+1-4
        DB  0
        DB  0
        DB  0

STORE3: DW  00
        DW  00
        DW  00
        DW  00

        DW  00
        DW  00
        DW  00
        DW  00

        DB  0
        DB  0
        DW  00
        DW  00
        DB  0
        DB  32
        DB  16+8+2+1
        DB  0
        DB  0
        DB  0

SPARE:  DB 42
;------------------------------------------------
FINISH          DEFL $
                LIST
                CLOSE
START           DEFL START
FINISH          DEFL FINISH
LENGTH          DEFL FINISH-START
(AMSTRAD)  ***** VERSION  5.0 *****


SOUNDCOD     EQU       28000            ;MACHINE CODE  DW  00
        DW  00

        DB  0
        DB  0
        DW  00
        DW  00
        DB  0
        DB  32
