; NETHERSD.ASM   V 11.0  NETHERWORLD Sound Driver (AMSTRAD/SPEC.128)  DavRog,1988


;******************************************************
SPECVERSION  EQU   0                ;0=AMSTRAD 1=SPEC

SOUNDCOD     EQU   32768            ;MACHINE CODE

SOUNDATA     EQU   SOUNDCOD + 1100   ;DATABLOCK ADDRESS
;******************************************************

             NOLIST

ENVSINDEX    EQU       SOUNDATA+200
TUNESINDEX   EQU       ENVSINDEX+100

ENVCOUNTS    EQU 0
ENTCOUNTS    EQU 2
ENVPTR       EQU 4
ENTPTR       EQU 6
ENV0         EQU 8
ENT0         EQU 10
ENVADR       EQU 12
ENTADR       EQU 14

CHANACTIVE   EQU 16
MAINCOUNT    EQU 17
DATAPTR      EQU 18
CONPTR       EQU 20
PTRREFR      EQU 22
PITCHSHIFT   EQU 24
NOISEDIS     EQU 25
CH_ENABLE    EQU 26
INTERVAL     EQU 27
CURRENTNOTE  EQU 28
CHORDTOGGLE  EQU 29
CURRENTDUR   EQU 30
volbalflag   equ 31

                ORG  SOUNDCOD
;*****
IF SPECVERSION
                WRITE "SPECCOD.BIN"
ELSE
                WRITE "NETHERSD.BIN"
ENDIF
;*****

START           DEFL $

;---------------------------------------
JUMPBLOCK:      JP PLAY25th
                JP SILENCE
                JP PLAY50TH
spec48flag      DB 0
BASICSTART:     LD E,1
                LD C,1
                jp dosound
time48.1        dw 00
time48.2        dw 00
time48.3        dw 00
key48           db 0
temper48        db 0
                JP INTRO48
                JP INGAME48
effvol          db 0
tunvol          db 0

;----------------------
DOSOUND:        CALL FINDBLOC      ;E=BLOC   HL=BLOCADR
                LD A,(HL)          ;C=CHAN   B=PRIORITY
                CP 9
                JR NC,NOCHANMARKER
                LD C,A
                INC HL
                LD A,(HL)
NOCHANMARKER:   CP 244
                LD B,10
                JR NZ,NOPRIMARKER
                INC HL
                LD B,(HL)
                INC HL
NOPRIMARKER     DEC C              ;FINDCHAN
                JR Z,TRY1
                DEC C
                JR Z,TRY2
                DEC C
                JR Z,TRY3           ;4=CHANALT
CHANALT:        LD A,(STORE1+CHANACTIVE)   ;chan 1 if poss.
                OR A
                JR Z,TRY1
                LD A,(STORE2+CHANACTIVE)
                OR A
                JR Z,TRY2
                JR TRY3                    ;else chan 3

TRY1:           LD DE,STORE1+CHANACTIVE
                LD A,(DE)
                LD C,A
                LD A,B
                SUB C
                RET C                   ;priority too low
                XOR A
                LD (DE),A               ;chan off while reset
                LD (STORE1+INTERVAL),A
                LD (STORE1+PITCHSHIFT),A
                ld (store1+volbalflag),a
                INC A
                LD (STORE1+MAINCOUNT),A
                LD (STORE1+DATAPTR),HL
                LD (STORE1+CONPTR),HL
                LD (STORE1+PTRREFR),HL
                LD A,B
                LD (DE),A
                RET

TRY2:           LD DE,STORE2+CHANACTIVE
                LD A,(DE)
                LD C,A
                LD A,B
                SUB C
                RET C
                XOR A
                LD (DE),A
                LD (STORE2+INTERVAL),A
                LD (STORE2+PITCHSHIFT),A
                ld (store2+volbalflag),a
                INC A
                LD (STORE2+MAINCOUNT),A
                LD (STORE2+DATAPTR),HL
                LD (STORE2+CONPTR),HL
                LD (STORE2+PTRREFR),HL
                LD A,B
                LD (DE),A
                RET

TRY3:           LD DE,STORE3+CHANACTIVE
                LD A,(DE)
                LD C,A
                LD A,B
                SUB C
                RET C
                XOR A
                LD (DE),A
                LD (STORE3+INTERVAL),A
                LD (STORE3+PITCHSHIFT),A
                ld (store3+volbalflag),a
                INC A
                LD (STORE3+MAINCOUNT),A
                LD (STORE3+DATAPTR),HL
                LD (STORE3+CONPTR),HL
                LD (STORE3+PTRREFR),HL
                LD A,B
                LD (DE),A
                RET

;------
SILENCE:        LD HL,255*256+255
                LD (STORE1+CHANACTIVE),HL  ;MAINCOUNT ALSO 255
                LD (STORE2+CHANACTIVE),HL
                LD (STORE3+CHANACTIVE),HL
                XOR A
                LD (OVERIDER+1),A         ;ESSENTIAL!!!!
                LD (NSEFLAG),A
                LD (BUFF+8),A
                LD (BUFF+9),A
                LD (BUFF+10),A
                LD (STORE1+CHANACTIVE),A
                LD (STORE2+CHANACTIVE),A
                LD (STORE3+CHANACTIVE),A
                LD A, %00111111          ;ALL GATES SHUT
                LD (BUFF+7),A
;***********
IF SPECVERSION
ALL13REGS:      LD HL,BUFF+13
                LD E,13
                XOR A
                JP NEXTREG
ELSE
ALL13REGS:      LD HL,BUFF+13
                LD DE,#F40D   ;13
                XOR A
                JP NEXTREG    ;RETS FROM THERE
ENDIF
;*******************

FINDBLOC:       LD   A,E
                ADD  A,A
                ADD  A,TUNESINDEX AND #00FF
                LD   L,A
                ADC  A,TUNESINDEX AND #FF00 /256
                SUB  L
                LD   H,A
                LD   E,(HL)
                INC  HL
                LD   D,(HL)
                LD HL,SOUNDATA
                ADD HL,DE
                RET

FINDENV:        LD   A,E                ;must not corrupt hl
                ADD  A,A
                ADD  A,ENVSINDEX AND #00FF
                LD   E,A
                ADC  A,ENVSINDEX AND #FF00 / 256
                SUB  E
                LD   D,A   ;-----
                LD  A,(DE)
                ADD A,SOUNDATA AND #00FF
                LD  C,A   ;-----
                INC  DE
                LD  A,(DE)
                ADC A,SOUNDATA AND #FF00 / 256
                LD B,A
                RET

;-------------------------------------PLAY-------------
PLAY25TH        CALL PLAYGEN
                JP ALLREGIST

PLAY50TH        LD A,0-0
                XOR 1
                LD (PLAY50TH+1),A
                JR Z,PART2
PART1           JP PLAYGEN    ;RETS FROM THERE
PART2           JP ALLREGIST

;-------
PLAYGEN         LD A,(STORE1+CHANACTIVE)
                OR A
                JR Z,C2
                LD  IX,STORE1
                LD IY,BUFF+8
                LD HL,(BUFF)
                LD (PITCHTEMP),HL
                LD HL,(STORE1+DATAPTR)
                CALL TESTCHAN
                LD (BUFF),HL

C2:             LD A,(STORE2+CHANACTIVE)
                OR A
                JR Z,C3
                LD  IX,STORE2
                LD IY,BUFF+9
                LD HL,(BUFF+2)
                LD (PITCHTEMP),HL
                LD HL,(STORE2+DATAPTR)
                CALL TESTCHAN
                LD (BUFF+2),HL

C3:             LD A,(STORE3+CHANACTIVE)
                OR A
                JR Z,C4
                LD IX,STORE3
                LD IY,BUFF+10
                LD HL,(BUFF+4)
                LD (PITCHTEMP),HL
                LD HL,(STORE3+DATAPTR)
                CALL TESTCHAN
                LD (BUFF+4),HL

C4              JP DOENSE   ;RETS FROM THERE

;***************
IF SPECVERSION

ALLREGIST:      XOR A
                LD HL,BUFF+10
                LD E,10
NEXTREG:        LD BC,65533
                OUT (C),E
                LD BC,49149
                LD A,(HL)
                DEC HL
                OUT (C),A
                DEC E
                JP P,NEXTREG
                RET
ELSE

ALLREGIST:      XOR  A
                LD   HL,BUFF+10  ;10
                LD   DE,#F40A    ;10
NEXTREG:        LD   B,D
                OUT  (C),E
                LD   BC,63168    ;(#F6*256+%11000000)
                OUT  (C),C
                OUT  (C),A
                LD   B,D
                LD   C,(HL)
                DEC  HL
                OUT  (C),C
                LD   BC,63104    ;(#F6*256+%10000000)
                OUT  (C),C
                OUT  (C),A
                DEC  E
                JP   P,NEXTREG
                RET

ENDIF
;*************

;FOR EACH OF THE 3 CHANNELS:

TESTCHAN:       DEC  (IX+MAINCOUNT)
                JP NZ,DOENV_ENT

                LD A,20
                LD (DECI+1),A        ;INIT.STOPHANG (STOPS POSSIBLE HANG-UPS)

DECI            LD A,0-0             ;SELF-MOD
                DEC A
                LD (DECI+1),A
                RET Z

                LD   A,(HL)
                INC  HL
                LD   E,(HL)
                INC HL

SUBSELECT    OR A

             JP   Z,DOPAUSE
             CP   6
             JR   C,STARTLOOP
             CP   101
             JP   C,NEWNOTE
             CP   228
             JP   C,COMPNOTE
             CP   255
             JP   Z,RETCONBLOC
             CP   244
             JR   Z,NEWPRIORITY

             SUB 230
             JR  Z,NOISE
             DEC A
             JR  Z,NOISENOCHECK
             DEC A
             JR  Z,QUICKOUT
             DEC A
             JR  Z,NEWENV
             DEC A
             JR  Z,NEWENT
             DEC A
             JR  Z,NEWENSE
             DEC A
             JP  Z,SETINTERVAL
             DEC A
             JR  Z,NEWKEY
             DEC A
             JR  Z,GONEWBLOC
             DEC A
             jr z,volbalonoff
             DEC A
             JP Z,OVERIDE

             ;any other val=FOLLOW THROUGH=SAFETY NET

KILLCHAN:       LD (IX+CHANACTIVE),0
                LD (IY+0),0             ;CH VOL
                RET

volbalonoff     ld (ix+volbalflag),e
                jp deci

NEWPRIORITY:    LD (IX+CHANACTIVE),E
                JP DECI

QUICKOUT:       LD (IX+MAINCOUNT),1     ;TIME SHARER
                DEC HL
                LD (IX+DATAPTR),L
                LD (IX+DATAPTR+1),H
                LD HL,0
                RET

STARTLOOP:      PUSH HL
                LD C,A             ;C=CHAN
                CALL DOSOUND
                POP HL
                JP DECI

NOISE:          LD A,(BUFF+7)      ;NO DRUMS IF FX NOISE ON CHAN 3
                AND %00100000      ;Gate open if bit NOT set
                JR Z,DECI
NOISENOCHECK:   LD A,1
                LD (NSEFLAG),A
                LD   A,E
                LD   (BUFF+6),A
                JP   DECI

NEWKEY:         LD   (IX+PITCHSHIFT),E
                JP   DECI

NEWENT:         CALL FINDENV
                LD (IX+ENTADR),C
                LD (IX+ENTADR+1),B
                JP DECI

NEWENV:         CALL FINDENV
                LD (IX+ENVADR),C
                LD (IX+ENVADR+1),B
                JP DECI

NEWENSE:        CALL FINDENV
                LD (ENSSTORE+12),BC
                JP DECI

GONEWBLOC:      LD   (IX+CONPTR+1),H
                LD   (IX+CONPTR),L
                CALL FINDBLOC
                JP   DECI

RETCONBLOC      LD   H,(IX+CONPTR+1)
                LD   L,(IX+CONPTR)
                LD A,(HL)
                INC A     ;TEST 255
                JP NZ,DECI
                LD H,(IX+PTRREFR+1)
                LD L,(IX+PTRREFR)
                JP DECI

OVERIDE         LD A,E
                LD (OVERIDER+1),A
                JP DECI

SETINTERVAL     LD (IX+INTERVAL),E
                JP DECI
;-----------------------------------------DO NOTEs--------
COMPNOTE:       AND 127
                DEC HL
                LD E,(IX+CURRENTDUR)

NEWNOTE:        ADD  A,(IX+PITCHSHIFT)

;*******
IF SPECVERSION
                SUB 12       ;HALVE FREQY IF SPECTRUM (AY CLOCKED AT 2 MHZ)
ENDIF
;*******

DOPAUSE:        LD   (IX+MAINCOUNT),E
                LD   (IX+CURRENTDUR),E
                LD   (IX+CURRENTNOTE),A
                LD   (IX+DATAPTR+1),H
                LD   (IX+DATAPTR),L

PITCHTAB        EQU  SOUNDATA
                ADD  A,A
                ADD  A,PITCHTAB AND #00FF
                LD   L,A
                ADC  A,PITCHTAB AND #FF00 /256
                SUB  L
                LD   H,A
                LD   DE,PITCHTEMP
                LDI
                LDI

                LD (IY+6),0   ;+6 for volbal

                PUSH IX           ;RESTART ENV/ent
                POP  DE
                LD   HL,8
                ADD  HL,DE
                LDI
                LDI
                LDI
                LDI
                LDI
                LDI
                LDI
                LDI

                XOR A
                LD HL,NSEFLAG
                OR  (HL)
                LD (HL),0
                LD   L,(IX+NOISEDIS)
                JR   Z,GATING

NOISEON:        LD  HL,(ENSSTORE+ENVADR)
                LD  (ENSSTORE+ENVPTR),HL
                LD  HL,00
                LD  (ENSSTORE),HL

GATING:         LD   A,(BUFF+7)
                AND  (IX+CH_ENABLE)
                OR   L
OVERIDER        OR  0-0             ;SELF MODABLE
                AND  %00111111      ;TOP 2 BITS OFF
                LD   (BUFF+7),A
;---------------------------------------------------

DOENV_ENT:      CALL ENGEN

                LD A,(IY+6)  ;would-be vol store
                ADD A,C
                SUB  128
                ld (iy+6),a  ;replace would-be
                ld c,a
                ld a,(ix+volbalflag)
                or a
                ld a,c

                jr nz,tune
                ld hl,effvol
                jp bal
tune            ld hl,tunvol

bal             sub (hl)
                jr nc,setvol
                ld a,0
setvol          LD   (IY+0),A

;-------------------
                LD HL,(PITCHTEMP)     ;PAUSE ?
                LD A,H
                OR L
                RET Z
                LD A,(IX+INTERVAL)    ;CHORD ?
                OR A
                JR NZ,DOCHORD
DOENT:          INC IX
                INC IX
                CALL ENGEN
                LD HL,(PITCHTEMP)
                LD B,0
;*************************
IF SPECVERSION
                ADD  HL,BC
                ADD HL,BC
                LD   C,128
                SBC HL,BC
                SBC  HL,BC
ELSE
                ADD HL,BC
                LD C,128
                SBC HL,BC
ENDIF
;************************
                RET
;--------------------------------------
DOCHORD:        DEC (IX+CHORDTOGGLE)
                LD A,(IX+CURRENTNOTE)
                JR Z,FINDSETPITCH
                ADD (IX+INTERVAL)
                LD (IX+CHORDTOGGLE),1

PITCHTAB        EQU  SOUNDATA
FINDSETPITCH:   ADD  A,A
                ADD  A,PITCHTAB AND #00FF
                LD   L,A
                ADC  A,PITCHTAB AND #FF00 /256
                SUB  L
                LD   H,A

                LD   E,(HL)
                INC HL
                LD  D,(HL)
                EX HL,DE
                RET
;-------------------
DOENSE:         LD IX,ENSSTORE
                CALL ENGEN

                LD HL, BUFF+6
                LD   A,(HL)
                ADD  A,C
                SUB  128
                LD   (HL),A
                CP 32
                RET C
NOISEOFF:       INC HL          ;HL=BUFF+7
                LD A,(HL)
                OR %00111000
                LD (HL),A
                RET
;--------------------------------------
ENGEN           PUSH IX
                POP  HL
                LD   D,(IX+ENVPTR+1)
                LD   E,(IX+ENVPTR)
                INC  (HL)
                LD   A,(DE)
                SUB  (HL)
                LD C,128        ;=0!
                RET  NZ
                LD   (HL),A
                INC DE
                LD  A,(DE)
                LD C,A
                INC  DE
                INC  HL
                INC  (HL)
                LD   A,(DE)
                SUB  (HL)
                RET  NZ
                LD   (HL),A
                INC  DE
                LD   A,(DE)
                INC  A
                JR   NZ,NEXTSECT
                LD   D,(IX+ENVADR+1)
                LD   E,(IX+ENVADR)
NEXTSECT:       LD   (IX+ENVPTR+1),D
                LD   (IX+ENVPTR),E
                RET

;---------------------

BUFF:     DW  00
          DW  00
          DW  00
          DB  0
          DB  %00111111
          DB  0
          DB  0
          DB  0
          Dw  16
          DB  10

wouldbe   db 0
          db 0
          db 0

PITCHTEMP:  DW 00

NSEFLAG:    DB 0

ENSSTORE: DW 00
          DW 10
          DW 00
          DW 04
          DW 00
          DW 18
          DW 00

;-----CHANNEL STORES

STORE1:   DW  00
          DW  00
          DW  00
          DW  00

          DW  00
          DW  00
          DW  00
          DW  00

          DB  0
          DB  0
          DW  00
          DW  00
          DW  00
          DB  0
          DB   8          ;NOISE DIS
          DB  32+16+4+2   ;CHAN ENABLE  (-4 'COS CHORUS=CH3 ALWAYS ON)
          DB  0
          DB  0
          DB  0
          DB  0
          db  0  ;volbalflag

STORE2: DW  00
        DW  00
        DW  00
        DW  00

        DW  00
        DW  00
        DW  00
        DW  00

        DB  0
        DB  0
        DW  00
        DW  00
        DW  00
        DB  0
        DB  16
        DB  32+8+4+1
        DB  0
        DB  0
        DB  0
        DB  0
        db  0

STORE3: DW  00
        DW  00
        DW  00
        DW  00

        DW  00
        DW  00
        DW  00
        DW  00

        DB  0
        DB  0
        DW  00
        DW  00
        DW  00
        DB  0
        DB  32
        DB  16+8+2+1
        DB  0
        DB  0
        DB  0
        DB  0
        db  0

;---------------------48K SOUND----------------

INTRO48         RET
INGAME48        RET
SPARE           DB 42

;---------
FINISH          DEFL $
                LIST
                CLOSE
START           DEFL START
FINISH          DEFL FINISH
LENGTH          DEFL FINISH-START
;*************************************************