; STORMSD.ASM      STORMLORD Sound Driver     J.Dave Rogers    1988


;******************
SPECVERSION     EQU       0             ;1 FOR SPECTRUM,0 FOR AMSTRAD

IF SPECVERSION
SOUNDCOD        EQU       61870
ELSE
SOUNDCOD        EQU       32768         ;machine code address.
ENDIF

SOUNDATA        EQU       soundcod+965  ;datablock address.
;******************

             NOLIST

ENVSINDEX    EQU       soundata+200
TUNESINDEX   EQU       ENVSINDEX+84

envcounts    EQU 0
entcounts    EQU 2
envptr       EQU 4
entptr       EQU 6
env0         EQU 8
ent0         EQU 10
envadr       EQU 12
entadr       EQU 14

chanactive   EQU 16
maincount    EQU 17   ;1
dataptr      EQU 18   ;2
conptr       EQU 20   ;2
ptrrefr      EQU 22   ;2
pitchshift   EQU 24   ;1
noiseflag    EQU 25   ;1
noisedis     EQU 26   ;1
ch_enable    EQU 27   ;1
advolreg     EQU 28   ;2
stophang     EQU 30   ;1
CURRENTDUR   EQU 31   ;1
INTERVAL     EQU 32   ;1
CURRENTNOTE  EQU 33   ;1
CHORDTOGGLE  EQU 34   ;1

             ORG  SOUNDCOD
;******
IF SPECVERSION
             WRITE "SPECCOD.BIN"
ELSE
             WRITE "STORMSD.BIN"
ENDIF
;*******

start        DEFL $

;-----------------------------------------------
JUMPBLOCK       JP PLAY
                JP SILENCE
BASIC_DEMO      LD E,1
                LD A,1
STARTA          JP STARTACHAN

PAUSER          ld hl,buff+7
                LD A,(hl)
                LD (restoreGATE+1),A
                LD (hl),%00111111
                push hl
                CALL ALL13REGS
                pop hl
restoregate     ld (hl),0-0
                RET

;-------------------------------------------------
STARTACHAN      LD C,A             ; a/c=chan num e=tuneblock num
                CALL FINDBLOC
                LD A,(HL)
                CP 9
                JR NC,nochanmarker
                LD C,A
                INC HL
                LD A,(HL)
NOCHANMARKER    CP 244
                LD B,10
                JR NZ, CH1TO3
                INC HL
                LD B,(HL)
                INC HL

CH1TO3          DEC C
                JR Z ,IXfound1
                DEC C
                JR Z, IXfound2
                DEC C
                JR Z, IXFOUND3

CHANALT         LD A,(STORE1+CHANACTIVE)     ;CH4= 1 / 2
                OR A
                JR Z,IXFOUND1        ;CH1 FREE
                LD A,(STORE2+CHANACTIVE)
                OR A
                JR Z,IXFOUND2        ;CH2 FREE
                JR IXFOUND3        ;USE CH3

IXFOUND1        LD IX,STORE1
                JR TRYSTART
IXFOUND2        LD IX,STORE2
                JR TRYSTART
IXFOUND3        LD IX,STORE3

TRYSTART        LD A,B
                CP (IX+CHANACTIVE)
                RET C
DOSTART         XOR A
                LD (IX+CHANACTIVE),A   ; 7. off while set up!
                LD (IX+DATAPTR),L
                LD (IX+DATAPTR+1),H
                LD (IX+CONPTR),L
                LD (IX+CONPTR+1),H
                LD (IX+PTRREFR),L
                LD (IX+PTRREFR+1),H

                LD (IX+MAINCOUNT),1
                LD (IX+PITCHSHIFT),A
                LD (IX+INTERVAL),A

                LD A,B
                AND 127    ;PRI >128 = high pri but RESETS TO LOW eg 138=10

                LD (IX+CHANACTIVE),A     ;activate
                RET

;-------------------------------------
SILENCE         LD HL,#FFFF
                LD  (STORE1+CHANACTIVE),HL  ;ALSO MAINCOUNT TO 255
                LD  (STORE2+CHANACTIVE),HL
                LD  (STORE3+CHANACTIVE),HL

                LD HL,BUFF+7
                LD (HL),%00111111
                XOR A
                INC HL
                LD (HL),A              ;volume registers 0
                INC HL
                LD (HL),A
                INC HL
                LD (HL),A

                LD (STORE1+CHANACTIVE),A
                LD (STORE2+CHANACTIVE),A
                LD (STORE3+CHANACTIVE),A

                JP ALL13REGS               ;RETS FROM THERE

;-------------------------subroutines
FINDBLOC        LD   A,E
                ADD  A,A
                ADD  A,TUNESINDEX AND #00FF
                LD   L,A
                ADC  A,TUNESINDEX AND #FF00 /256
                SUB  L
                LD   H,A
                LD   E,(HL)
                INC  HL
                LD   D,(HL)
                LD HL,soundata
                ADD HL,DE
                RET

FINDENV         LD   A,E
                ADD  A,A
                ADD  A,ENVSINDEX AND #00FF
                LD   E,A
                ADC  A,ENVSINDEX AND #FF00 / 256
                SUB  E
                LD   D,A

                LD  A,(DE)
                ADD A,SOUNDATA AND #00FF
                LD  C,A

                INC  DE
                LD  A,(DE)
                ADC A,SOUNDATA AND #FF00 / 256
                LD B,A

                RET

;-------------------MAIN CALL--------EVERY 1/50 SECOND-----------------------

PLAY            LD  IX,STORE1
                LD HL,(BUFF)
                CALL TESTCHAN
                LD (BUFF),HL

                LD HL, (BUFF+2)
                LD  IX,STORE2
                CALL TESTCHAN
                LD (BUFF+2),HL

                LD HL,(BUFF+4)
                LD   IX,STORE3
                CALL TESTCHAN
                LD (BUFF+4),HL

                CALL DOENSE
                JP ALLREGIST   ;10 ONLY!
;***********
IF SPECVERSION

ALL13REGS       XOR A
                LD HL,BUFF+13
                LD E,13
                JR NEXTREG

ALLREGIST       XOR A
                LD HL,BUFF+10
                LD E,10

NEXTREG         LD BC,65533
                OUT (C),E
                LD BC,49149
                LD A,(HL)
                DEC HL
                OUT (C),A
                DEC E
                JP P,NEXTREG
ELSE

ALL13REGS       XOR A
                LD HL,BUFF+13
                LD DE,#F40D
                JR NEXTREG

ALLREGIST       XOR  A
                LD   HL,BUFF+10
                LD   DE,#F40A       ;D=Psg data port, E=loop counter

nextreg         LD   B,D
                OUT  (C),E
                LD   BC,#F6*256+%11000000
                OUT  (C),C
                OUT  (C),A
                LD   B,D
                LD   C,(HL)
                DEC  HL
                OUT  (C),C
                LD   BC,#F6*256+%10000000
                OUT  (C),C
                OUT  (C),A
                DEC  E
                JP   P,nextreg
ENDIF
;*************
                RET     ;---------->>>>>>> ouT

;FOR EACH OF THE 3 CHANNELS:

TESTCHAN        LD  A,(IX+CHANACTIVE)
                OR A
                RET Z          ;HL STILL CONTAINS PITCH!!

                LD (PITCHTEMP),HL
                DEC  (IX+maincount)
                JP NZ,DOENV_ENT
                LD A,20
                LD (DECI+1),A

                LD  H,(IX+dataptr+1)
                LD  L,(IX+DATAPTR)

DECI            LD A,0-0
                DEC A
                LD (DECI+1),A          ;SELF-MOD
                RET Z

                LD   A,(HL)
                INC  HL
                LD   E,(HL)
                INC HL

;-----------------------
SUBSELECT  CP 255
           JP Z,RETCONBLOC
           CP 225
           JR NC,SPECIALS   ; >=225

           OR A
           JP   Z,DOPAUSE     ;pitch 0 = pause
           CP  9
           JR  C,STARTLOOP   ;<9 = CHAN to start, FOLLOWED BY BLOC num
           CP   101
           JP   C,NEWNOTE     ;LESS THAN 100=normal note
           CP   127
           JR   C,NOISE      ;102 TO 126     K=102=0  TO  X=115=13

           JP COMPNOTE   ;whats left = 128 TO 224 = COMPRESSED NOTES

SPECIALS   SUB 225
           JP  Z,PLAYRAND     ;PLAY FROM RANDNOTE STORE(+PITCHSHIFT)
           DEC A
           JR   Z,NEWENT      ;set new tone-envelope for current channel
           DEC A
           JR   Z,NEWENV      ;set new volume-env for current chan
           DEC A
           JR   Z,NEWENSE     ;set new noise-envelope
           DEC A
           JP  Z,NEWRANDNOTE  ;226/ander. RANDnote = rnd*255 AND ANDER
           DEC A
           JR   Z,GONEWBLOCK  ;play a given tunebloc,then return to 1st
           DEC A
           JP   Z,NEWKEY      ;change musical key for current chan
           DEC A
           JR  Z,SETINTERVAL
           DEC A
           JR Z, KILLCHAN

           JR DECI
          ;ANY OTHER VAL=SAFETY NET

KILLCHAN        LD (IX+CHANACTIVE),0
killvol         LD H,(IX+ADVOLREG+1)
                LD L,(IX+ADVOLREG)    ;HL=address of vol register,current chan
                LD (HL),0
                LD HL,0
                RET


STARTLOOP       PUSH HL
                PUSH IX           ;A=CHAN E=TUNEBLOC
                CALL STARTACHAN
                POP IX
                POP HL
                JR DECI

NOISE           SUB 102
                LD   (BUFF+6),A        ;noisepitch
                LD   (IX+noiseflag),1
                DEC HL
                JP   DECI

NEWKEY          LD   (IX+pitchshift),E
                JP   DECI

NEWENT          CALL FINDENV       ;returns with envelope address in BC
                LD (IX+ENTADR),C
                LD (IX+ENTADR+1),B
                JP DECI

NEWENV          CALL FINDENV
                LD (IX+ENVADR),C
                LD (IX+ENVADR+1),B
                JP DECI

NEWENSE         CALL FINDENV
                LD (ENSSTORE+12),BC
                JP DECI

GONEWBLOCK      LD   (IX+conptr+1),H
                LD   (IX+conptr),L    ;leaving bloc so store ptr
                CALL FINDBLOC
                JP   DECI

RETCONBLOC      LD   H,(IX+conptr+1)  ;(ptr re-enters original "conductor" bloc)
                LD   L,(IX+conptr)
                LD   A,(HL)
                INC A                 ;TEST FOR 255,end-of-conductor-bloc marker
                JR   NZ,NOTEND
                LD   H,(IX+ptrrefr+1) ;refresh
                LD   L,(IX+ptrrefr)
notend          JP   DECI

SETINTERVAL     LD (IX+INTERVAL),E
                JP DECI

NEWRANDNOTE     PUSH HL
                LD HL,10418  ;RANDSEED,SELF MOD LATER
                LD C,L
                LD B,H
                ADD HL,HL
                ADD HL,HL
                ADD HL,BC
                ADD HL,HL
                ADD HL,HL
                ADD HL,HL
                ADD HL,BC
                LD (NEWRANDNOTE+2),HL

                LD A,H               ;A=0 TO 255
                AND E                ;E = ANDER = range limiter
                LD C,A
                LD B,0      ;BC=RAND NUMBER 0 TO 255
                LD HL,RANDGROUP
                ADD HL,BC    ;HL POINTS TO ITEM IN GROUP
                LD A,(HL)
                LD (PLAYRAND+1),A

                POP HL
                JP DECI

RANDGROUP       DB 0, 3, 5, 7, 10, 7, 10,    12,15,17
                DB 12,15,17,19,22, 12,15,17,19,22
                DB 19,22,  24,27,29,31,34,  24,27,29, 0,0,0    ;33 ITEMS

COMPNOTE        AND 127               ;a=note
                LD E,(IX+CURRENTDUR)  ;E=DUR
                DEC HL
                JP subselect          ;now works on pauses also

PLAYRAND        LD A,42   ;SELF MODIFIED VALUE

NEWNOTE         ADD  A,(IX+pitchshift)   ;A=notenum
;*****
IF SPECVERSION
                SUB 12
ENDIF
;*****
DOPAUSE         LD (IX+maincount),E    ;E=duration
                LD (IX+CURRENTNOTE),A    ;for chorder
                LD (IX+CURRENTDUR),E     ;FOR COMPRESSOR

                LD (IX+DATAPTR+1),H
                LD (IX+DATAPTR),L

                CALL FINDSETPITCH   ;A=PITCH NUM

                XOR A                  ;A=0
                LD (IX+CHORDTOGGLE),A   ;SO HI HARMONY 1ST

                LD H, (IX+ADVOLREG+1)  ;ZERO VOL
                LD L, (IX+ADVOLREG)
                LD (HL),A

                PUSH IX           ;RESTART ENV/ent
                POP  DE           ;DE=start of chan store
                LD   HL,8
                ADD  HL,DE        ;HL=start of chan store+8
                LDI
                LDI
                LDI
                LDI
                LDI
                LDI
                LDI
                LDI

                DEC  (IX+noiseflag)      ;test noiseflag   1=ON 0=OFF
                LD  (IX+NOISEFLAG),A     ;RESET EVERY TIME!
                LD  L,(IX+NOISEDIS)      ;DEFAULT DISABLE
                JR   NZ,GATING

NOISEon         LD HL,(ENSSTORE+envadr)  ;restart noise envelope
                LD (ENSSTORE+envptr),HL
                LD H,A
                LD L,A
                LD (ENSSTORE),HL         ;L=0,no noisedisable

GATING          LD   A,(BUFF+7)
                AND  (IX+ch_enable)      ;chan ENable (pitch AND noise on)
                OR   L                   ;noise DISable
                AND 32+16+8+4+2+1        ;SAFETY, top 2 bits must remain off
                LD   (BUFF+7),A          ;FINAL RESULT IN A!
;------------------------------------
                           ;IX points to volume-env workspace for current chan
DOENV_ENT       CALL ENGENERAL
                LD   H,(IX+advolreg+1)
                LD   L,(IX+advolreg)
                LD   A,(HL)
                ADD  A,C
                SUB  128
                LD   (HL),A

ISITAPAUSE      LD HL,(PITCHTEMP)
                LD A,H
                OR L
                RET Z
ISITACHORD      LD A,(IX+interval)
                OR A
                JR NZ,DOCHORD
DOENT           INC  IX  ;make IX work on tone-envelope workspace,2 bytes along
                INC  IX
                CALL ENGENERAL
                LD HL,(PITCHTEMP)
                LD B,0
;*******************
IF SPECVERSION
                ADD HL,BC
                ADD HL,BC
                LD C,128
                SBC HL,BC
                SBC HL,BC
ELSE
                ADD  HL,BC
                LD   C,128
                SBC  HL,BC
ENDIF
;*******************:
                RET     ;WITH PITCH IN HL

DOCHORD         DEC (IX+CHORDTOGGLE)
                LD A,(IX+CURRENTNOTE)
                JR Z,FINDSETPITCH
                ADD (IX+INTERVAL)
                LD (IX+CHORDTOGGLE),1

pitchtab        equ  soundata
FINDSETPITCH    ADD  A,A                     ;get new pitch from pitchtable
                ADD  A,PITCHTAB AND #00FF
                LD   L,A
                ADC  A,PITCHTAB AND #FF00 /256
                SUB  L
                LD   H,A      ;HL=ADR OF PITCH IN TABLE

                LD   DE,PITCHTEMP   ;DE=DESTINATION
                LDI                  ;PEEK(HL) > PEEK(DE)
                LDI
                LD HL,(PITCHTEMP)
                RET

DOENSE          LD   IX,ENSSTORE  ;IX now = noise envelope workspace
                CALL ENGENERAL    ;returns with "noise shift+128" in C
                LD HL, BUFF+6
                LD   A,(HL)   ;get current noise value
                ADD  A,C
                SUB  128          ;add shift, minus 128
                LD   (HL),A   ;replace
                CP 33
                RET C
noiseoff        INC HL     ;HL=buff+7
                LD A,(HL)
                OR 32+16+8
                LD (HL),A
                RET

;------------------------
ENGENERAL       PUSH IX
                POP  HL                ;points to counts
                LD   D,(IX+ENVPTR+1)   ;points to envelope
                LD   E,(IX+ENVPTR)
                INC  (HL)     ;inc count
                LD   A,(DE)
                SUB  (HL)
                LD   C,128    ;DEFAULT (C= 128 = 0 )
                RET  NZ
                LD   (HL),A
                INC DE        ;move along envelope
                LD  A,(DE)
                LD  C,A       ;C HOLDS INCREMENT
                INC  DE       ;point at repeats number
                INC  HL
                INC  (HL)     ;point at repeats count
                LD   A,(DE)
                SUB  (HL)
                RET  NZ
                LD   (HL),A
                INC  DE
                LD   A,(DE)
                INC  A
                JR   NZ,nextsect
                LD   D,(IX+envadr+1)
                LD   E,(IX+envadr)
nextsect        LD   (IX+envptr+1),D
                LD   (IX+envptr),E
                RET
;--------------------------------------------------------

BUFF      DW  00       ;a pitch
          DW  00       ;b pitch
          DW  00       ;c pitch
          DB  0        ;noise pitch
          DB  %00111111  ;gates
          DB  0        ;a vol
          DB  0        ;b vol
          DB  0        ;c vol
          DW  100      ;hard env len
          DB  10       ;hard env type

PITCHTEMP  DW 00

ensstore  DW 00 ;ENSCOUNTS
          DW 10
          DW 00 ;ENSPTR
          DW 04
          DW 00 ;ENS0
          DW 18
          DW 00 ;ENSADR
;----------------------------------
;channel stores

STORE1    DW  00     ;env counts
          DW  00     ;ENT COUNTS
          DW  00     ;ENV PTR
          DW  00     ;ENT PTR

          DW  00     ;ENV ZEROERS
          DW  00     ;ENT ZEROERS
          DW  00     ;ENV ADDR
          DW  00     ;ENT ADDR

          DB  0      ;CHAN ACTIVE
          DB  0      ;MAIN COUNT
          DW  00     ;MAIN PTR
          DW  00     ;CON PTR
          DW  00     ;PTR REFRESH
          DB  0      ;PITCHSHIFT
          DB  0      ;NOISE FLAG
          DB   8        ;NOISE DIS
          DB  32+16+4+2 ;chan ENable
          DW  BUFF+8    ;AD OF VOL REG
          DB  0
          DB  0      ;CURRENTDUR (FOR COMPRESSOR)
          DB  0
          DB  0
          DB  0

STORE2  DW  00
        DW  00
        DW  00
        DW  00

        DW  00
        DW  00
        DW  00
        DW  00

        DB  0
        DB  0
        DW  00
        DW  00
        DW  00
        DB  0
        DB  0
        DB  16
        DB  32+8+4+1
        DW  BUFF+9
        DB  0
        DB  0
        DB  0
        DB  0
        DB  0

STORE3  DW  00
        DW  00
        DW  00
        DW  00

        DW  00
        DW  00
        DW  00
        DW  00

        DB  0
        DB  0
        DW  00
        DW  00
        DW  00
        DB  0
        DB  0
        DB  32
        DB  16+8+2+1
        DW  BUFF+10
        DB  0
        DB  0
        DB  0
        DB  0
        DB  0

        DB 42     ;SPARE
;-----------------------
FINISH          DEFL $
                LIST
                CLOSE
START           DEFL START
FINISH          DEFL FINISH
LENGTH          DEFL FINISH-START


;******************
SPECVERSION     EQU       0             ;1
        DB  0
        DW  00
        DW  00
        DW  00
        DB  0
        DB  0
        DB  32
        DB  16+8+2+1
        DW  BUFF+10
        DB  0
        DB  0
        DB  0
        DB  0
        DB  0

        DB 42     ;SPARE
;-----------------------
FINISH          DEFL $
                LIST
                CLOSE
START           DEFL START
FINI