; ZYNAPSSD.ASM      ZYNAPS Sound Driver        JDRogers


                NOLIST

MCODE           EQU       31080     ;inc buff/variables/stores
PITCHTAB        EQU       &DE40+8     ;100*2  ------------( ^ SELFCOMPACTING)
ENVSINDEX       EQU       &DE40+190+8     ;80
ENVS            EQU       &E640+8        ;380
CON1            EQU       20800+1000  ;1500
CON2            EQU       21300+2000  ;1500
CON3            EQU       21800+3000  ;1500
TUNESINDEX      EQU       &DE40+190+71+8  ;1100
TUNEBLOCS       EQU       22400+5000  ;?
;
envcounts   EQU 0
entcounts   EQU envcounts+2
enscounts   EQU entcounts+2
envptr      EQU enscounts+2
entptr      EQU envptr+2
ensptr      EQU entptr+2
envrefr      EQU ensptr+2
entrefr      EQU envrefr+2
ensrefr      EQU entrefr+2
env0        EQU ensrefr+2
ent0        EQU env0+2
ens0        EQU ent0+2
envadr      EQU ens0+2
entadr      EQU envadr+2
ensadr      EQU entadr+2
chanactive  EQU ensadr+2
maincount   EQU chanactive+1
spendflag   EQU maincount+1
mainptr     EQU spendflag+1
conptr      EQU mainptr+2
ptrrefr     EQU conptr+2
pitchshift  EQU ptrrefr+2
noiseflag   EQU pitchshift+1
noisedis    EQU noiseflag+1
ch_enable   EQU noisedis+1
advolreg    EQU ch_enable+1
;

                ORG  MCODE
                WRITE "ZYNAPSSD.BIN"
start           DEFL $

JUMPBLOCK       JP STARTUP_TUNE
                JP KILLTUNE
                JP PLAY

FX1             LD A,14
                JR STARTONE
FX2             LD A,15
                LD B,16
                JR STARTTWO
FX3             LD A,17
                JR STARTACHAN
FX4             LD A,18
                JR STARTACHAN
FX5             LD A,19
                JR STARTACHAN
FX6             LD A,20
                JR SPECIAL
FX7             LD A,26
                LD B,27
                JR STARTTWO
FX8             LD A,22
                JR STARTACHAN
FX9             LD A,23
                JR STARTACHAN
FX10            LD A,24
                JR STARTACHAN
FX11            LD A,25
                JR STARTACHAN
FX12            LD A,15
                JR STARTACHAN
FX13            LD A,16
                JR STARTACHAN
FX14            LD A,28
                JR STARTACHAN
FX15            LD A,29
                JR STARTACHAN
FX16            LD A,30
                LD B,31
                JR STARTTWO

SPECIAL         LD B,21
                JR STARTTWO

STARTONE        LD C,A
                LD A,1
                JR findstore

STARTTWO        CALL STARTACHAN
                LD A,B

STARTACHAN      LD C,A       ;STORE A
                LD A,(FREECHAN)  ;-----
                XOR 1
                LD (FREECHAN),A  ;FREECHAN GOES 2,3,2,3....
findstore       LD IX,STORE1
                CP 2
                JR C ,OK
                LD IX,STORE2
                CP 3
                JR C,OK
                LD IX,STORE3    ;------
OK              LD HL,TUNESINDEX
                LD  A,C
                ADD A,A
                LD  D,0
                LD  E,A
                ADD HL,DE
                LD  E,(HL)
                INC HL
                LD D,(HL)  ;DE=ADR OF TUNEBLOC

SUBSET          LD   (IX+chanactive),1  ;CHAN ON
                LD   (IX+maincount),1  ;allow 8 passes to do specials
                XOR A
                LD   (IX+PITCHSHIFT),A
                LD   (OVRIDE),A
                LD   (IX+MAINPTR),E  ;mainptr/ptr refresh=START OF CONDUCTORS
                LD   (IX+MAINPTR+1),D
                LD   (IX+CONPTR),E
                LD   (IX+CONPTR+1),D
                LD   (IX+PTRREFR),E
                LD   (IX+PTRREFR+1),D
                RET
;
;

KILLTUNE        XOR A
                LD   (STORE1+CHANACTIVE),A      ;killtune flagS 0
                LD   (STORE2+CHANACTIVE),A
                LD   (STORE3+CHANACTIVE),A
                LD (BUFF+8),A
                LD (BUFF+9),A
                LD (BUFF+10),A
                JP QUIETSTART

STARTUP_TUNE    LD A,3
                LD (FREECHAN),A
                LD   A,11 ;---CHAN1
                CALL STARTONE
                LD   A,12  ;---CHAN2
                CALL STARTACHAN
                LD   A,13  ;---CHAN3
                CALL STARTACHAN
QUIETSTART      LD   A,1+2+4+8+16+32
                LD   (BUFF+7),A

ALLREGIST       XOR  A
                LD   HL,BUFF+13          ;register buffer
                LD   DE,#F40D            ;D=Psg data port, E=counter
nextreg         LD   B,D
                OUT  (C),E               ;output register No
                LD   BC,#F6*256+%11000000
                OUT  (C),C               ;tell PSG to latch reg No
                OUT  (C),A               ;PSG to inactive
                LD   B,D
                LD   C,(HL)              ;C=register data
                DEC  HL
                OUT  (C),C               ;output register data
                LD   BC,#F6*256+%10000000
                OUT  (C),C               ;tell PSG to read reg data
                OUT  (C),A               ;PSG to inactive
                DEC  E
                JP   P,nextreg
                RET

;--------------------------------

PLAY            CALL ALLREGIST  ;throw all buffer into actual chip
MAINLOOP        LD   IX,STORE1  ;IX points to chan1 store
                LD   IY,BUFF
                CALL TESTCHAN
                CALL DOENSE
                LD   IX,STORE2  ;chan2
                LD   IY,BUFF+2
                CALL TESTCHAN
                LD   IX,STORE3  ;chan3
                LD   IY,BUFF+4
                CALL TESTCHAN
                RET ;--------------------------->>>>>>> out !!


TESTCHAN        LD   A,(IX+CHANACTIVE)  ;CHAN ACTIVE?
                OR A
                RET Z
                DEC  (IX+maincount)    ;duration counts
                CALL Z,READdecide
                LD A, (IX+CHANACTIVE)
                OR A
                RET Z
                CALL DOENVELOPE
                CALL DOENT
                RET  ;--------------->> next chan

INCPTR          INC  HL
CONTPTR         LD   (IX+mainptr+1),H
                LD   (IX+mainptr),L

READdecide      LD   H,(IX+mainptr+1) ;main ptr address
                LD   L,(IX+mainptr)
DECI            LD   A,(HL)           ;a=peek(ptr)
                INC  HL
                LD   E,(HL)           ;e=peek(ptr+1)

;AFTER SUBSELECT,ALL RETURN TO INCPTR OR CONTPTR

;----------------subroutines----------
SUBSELECT       CP   0            ;A=VALUE
                JP   Z,DOPAUSE
                CP   101
                JP   C,NEWNOTE    ;LESS THAN 100=normal note
                CP   220
                JP   C,SINGLENOTE
                CP   228
                JR   Z,NOISE
                CP   225
                JR   Z,KILLCHAN
                CP   233
                JR   Z,NEWENT
                CP   232
                JR   Z,NEWENV
                CP   234
                JP   Z,NEWENSE
                CP   229
                JP   Z,NEWBLOCK
                CP   230
                JR   Z,NEWKEY
                CP   235
                JR   Z,OVERIDE
                CP   236
                JP   Z,SWAP
                CP   255
                JP   Z,GOCONDUCTOR

                JP SINGLENOTE    ;SAFETY NET

KILLCHAN        LD (IX+CHANACTIVE),0
                LD H,(IX+ADVOLREG+1)
                LD L,(IX+ADVOLREG)
                LD (HL),0
                RET

NOISE           LD   A,E
                LD   (BUFF+6),A  ;noisepitch
                LD   (IX+noiseflag),1
                INC  HL
                JP   DECI          ;follows directly to note (or pause)

NEWKEY          LD   (IX+pitchshift),E     ;the rest do NOT:
                JR   INCPTR

OVERIDE         LD   A,E
                LD   (OVRIDE),A
                JR   INCPTR

SWAP            LD   BC,(TUNESINDEX)   ;swaps addresses of tuneblocs 0/1
                PUSH BC
                LD   BC,(TUNESINDEX+2)
                LD   (TUNESINDEX),BC
                POP  BC
                LD   (TUNESINDEX+2),BC
                JP   CONTPTR

NEWENV          PUSH IX
ENVGEN          LD   A,E
                ADD  A,A
                ADD  A,ENVSINDEX AND #00FF
                LD   E,A
                ADC  A,ENVSINDEX AND #FF00 / 256
                SUB  E
                LD   D,A
                LD   A,(DE)
                LD   (IX+envadr),A
                INC  DE
                LD   A,(DE)
                LD   (IX+envadr+1),A
                POP IX
                JP   INCPTR

NEWENT          PUSH IX
                INC IX
                INC IX
                JR ENVGEN

NEWENSE         PUSH IX
                LD IX,STORE1+4
                JP ENVGEN

NEWBLOCK        INC  HL
                LD   (IX+conptr+1),H
                LD   (IX+conptr),L  ;leaving con so store conptr
                LD   A,E
                ADD  A,A
                ADD  A,TUNESINDEX AND #00FF
                LD   L,A
                ADC  A,TUNESINDEX AND #FF00 /256
                SUB  L
                LD   H,A        ;HL now points to 2byte blocaddress
                LD   E,(HL)
                INC  HL
                LD   D,(HL)
                EX   HL,DE      ;HL=ADDR
                JP   CONTPTR

GOCONDUCTOR     LD   H,(IX+conptr+1)  ;(ptr enters conductor)
                LD   L,(IX+conptr)
                LD   A,(HL)
                CP   255        ;end of conductor-bloc ?
                JP   NZ,CONTPTR
init            LD   H,(IX+ptrrefr+1)  ;refresh
                LD   L,(IX+ptrrefr)
                JP   CONTPTR

SINGLENOTE      AND 127
                DEC HL
                LD E,8

NEWNOTE         ADD  A,(IX+pitchshift)             ;A=notenum
DOPAUSE         LD   (IX+maincount),E              ;E=duration
                ADD  A,A                   ;get new pitch from tab
                ADD  A,PITCHTAB AND #00FF
                LD   E,A
                ADC  A,PITCHTAB AND #FF00 /256
                SUB  E
                LD   D,A
                LD   A,(DE)
                LD   (IY+0),A
                INC  DE
                LD   A,(DE)
                LD   (IY+1),A
                PUSH HL
                PUSH IX            ;RESTART ENV/ent
                POP  DE
                LD   HL,18
                ADD  HL,DE
                LDI
                LDI
                LDI
                LDI
                LDI
                LDI
                LDI
                LDI
                LDI
                LDI
                DEC  HL  ;refresh copies of env/ent addresses
                DEC  HL
                DEC  HL
                DEC  HL
                INC DE
                INC DE
                LDI
                LDI
                LDI
                LDI
                LD A,0
                LD (STORE1+4),A
                LD (STORE1+5),A
                LD A,(STORE1+28)
                LD (STORE1+10),A
                LD (STORE1+16),A
                LD A,(STORE1+29)
                LD (STORE1+11),A
                LD (STORE1+17),A
                LD   H,(IX+advolreg+1)   ;zero vol buff-reg this chan
                LD   L,(IX+advolreg)
                LD   (HL),0
                LD   A,(BUFF+7)  ;----GATING---
                AND  (IX+ch_enable)      ;chan ENable
                DEC  (IX+noiseflag)      ;test noiseflag
                JR   Z,NOISEon
                OR   (IX+NOISEDIS)      ;noise DISable
NOISEon         LD   HL,OVRIDE         ;GATES-OVERIDE
                OR   (HL)
                AND 32+16+8+4+2+1
                LD   (BUFF+7),A  ;FINAL RESULT IN A!
                LD   (IX+NOISEFLAG),0    ;reset noiseflag
                POP  HL
GETOUT          INC HL
                LD (IX+MAINPTR+1),H
                LD  (IX+MAINPTR),L
                RET

DOENVELOPE      PUSH IX        ;hl points to env counts
                POP  HL
                LD   D,(IX+envptr+1)  ;de points to env itself
                LD   E,(IX+envptr)
                INC  (HL)
                LD   A,(DE)
                SUB  (HL)
                RET  NZ
                LD   (HL),A    ;TIME UP change vol
                PUSH HL
                LD   H,(IX+advolreg+1)
                LD   L,(IX+advolreg)
                INC  DE
                LD   A,(DE)
                ADD  A,(HL)
                SUB  128
                LD   (HL),A
                POP  HL
                JR   contenv

DOENT           INC  IX
                INC  IX
                PUSH IX
                POP  HL
                LD   D,(IX+envptr+1)
                LD   E,(IX+envptr)
                INC  (HL)
                LD   A,(DE)
                SUB  (HL)
                RET  NZ
                LD   (HL),A    ;TIME UP
                PUSH HL
                LD   H,(IY+1)
                LD   L,(IY+0)
                INC  DE
                LD   B,A
                LD   A,(DE)
                LD   C,A
                ADD  HL,BC
                LD   C,128
                SBC  HL,BC
                LD   (IY+1),H
                LD   (IY+0),L
                POP  HL
                JR   contenv

DOENSE          LD   IX,STORE1+4
                PUSH IX
                POP HL
                LD   D,(IX+ENVPTR+1)
                LD   E,(IX+ENVPTR)
                INC  (HL)
                LD   A,(DE)
                SUB  (HL)
                RET  NZ
                LD   (HL),A
                LD   A,(BUFF+6) ;TIME UP
                LD   C,A
                INC  DE
                LD   A,(DE)
                ADD  A,C
                SUB  128
                AND 15
                LD   (BUFF+6),A
contenv         INC  DE
                INC  HL
                INC  (HL)
                LD   A,(DE)
                SUB  (HL)
                RET  NZ
                LD   (HL),A      ;STEPS UP
                INC  DE
                LD   A,(DE)
                INC  A           ;(test for a=255)
                JP   NZ,nextsect
                LD   D,(IX+envrefr+1)    ;refresh
                LD   E,(IX+envrefr)
nextsect        LD   (IX+envptr+1),D
                LD   (IX+envptr),E
                RET
;---------------------------

BUFF      DW  00       ;a pitch
          DW  00       ;b pitch
          DW  00       ;c pitch
          DB  0        ;noise pitch
          DB  32+16+8  ;gates
          DB  0        ;a vol
          DB  0        ;b vol
          DB  0        ;c vol
          DW  00       ;hard env len
          DB  0        ;hard env type

OVRIDE    DB  0  ;GATES OVERIDE
KILLFLAG  DB  0
FREECHAN  DB  0

STORE1    DW  00        ;+0/1 ent counts
       DW  00        ;+2/3 ENT COUNTS
     DW  00        ;+4/5 ENSE COUNTS
     DW  00        ;+6/7 ENV PTR
     DW  00        ;+8/9 ENT PTR
     DW  00        ;+10/11 ENSE PTR
     DW  00        ;+12/13 ENV REFRESH
     DW  00        ;+14/15 ENT REFRESH
     DW  00        ;+16/17 ENSE REFRESH
     DW  00        ;+18/19 ENV ZEROERS
     DW  00        ;+20/21 ENT ZEROERS
     DW  00        ;+22/23 ENSE ZEROERS
     DW  00        ;+24/25 ENV ADDR
     DW  00        ;+26/27 ENT ADDR
     DW  00        ;+28/29 ENSE ADDR
     DB  0    ;CHAN ACTIVE
     DB  0         ;+30 MAIN COUNT
     DB  0         ;+31 SPECIALS PENDING FLAG
     DW  00        ;+32/33 MAIN PTR
     DW  00        ;+34/35 CON PTR
     DW  00        ;+36/37 PTR REFRESH
     DB  0         ;+38/39 PITCHSHIFT
     DB  0         ;+40 NOISE FLAG
     DB   8        ;+41 NOISE DIS
     DB  32+16+4+2 ;+42 chan ENable
     DW  BUFF+8    ;+43/44 AD OF VOL REG

STORE2  DW  00
      DW  00
     DW  00
     DW  00
     DW  00
     DW  00
     DW  00
     DW  00
     DW  00
     DW  00
     DW  00
     DW  00
     DW  00
     DW  00
     DW  00
    DB 0
     DB  0
     DB  0
     DW  00
     DW  00
     DW  00
     DB  0
     DB  0
     DB  16        ;NOISE DIS
     DB  32+8+4+1  ;chan ENable
     DW  BUFF+9    ;AD OF VOL REg

STORE3  DW  00
      DW  00
     DW  00
     DW  00
     DW  00
     DW  00
     DW  00
     DW  00
     DW  00
     DW  00
     DW  00
     DW  00
     DW  00
     DW  00
     DW  00
     DB  0
   DB   0
     DB  0
     DW  00
     DW  00
     DW  00
     DB  0
     DB  0
     DB  32
     DB  16+8+2+1
     DW  BUFF+10

FINISH          DEFL $
                LIST
                CLOSE
START           DEFL START
FINISH          DEFL FINISH
LENGTH          DEFL FINISH-START EQU       &DE40+8     ;1